/*
** File Name : button.cpp
**
**     User Interface Generator Library For TC++
**     ~    ~         ~
**     Copyright (c) 1990,1991 M.Takayanagi (SSC Co.,Ltd.)
**
**			BUTTON CLASS
**                      ~~~~~~~~~~~~
*/

#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <ctype.h>
#include <dos.h>
#include <string.h>
#include "uiglib.h"

/*
** I{^imFLjꂽ̏
*/
int	BUTTON_EXIT::activate(PANEL& p)
{
	printf("\007");
	POPWIN_YES_NO	pop(10,30," I܂@H ");
	pop.open();
	if (pop.activate()) {
		return(exit_code);	// ImF xD̏ꍇ
	} else {
		return(PANEL_RESUME);	// ImF mD̏ꍇ
	}
}

/*
** I{^imFjꂽ̏
*/
int	BUTTON_QUIT::activate(PANEL& p)
{
	printf("\007");
	return(exit_code);
}

/*
** ͍ڂɕZbg{^
*/
BUTTON_PUT_STRING::BUTTON_PUT_STRING(int l, int c, unsigned int a, char *b, 
			unsigned int k, INPUT *inp, char *s, 
			FENCE fe, unsigned int fa):
	     BUTTON(l,c,a,b,k,fe,fa) 
{
	input = inp;
	str = s;
}

int	BUTTON_PUT_STRING::activate(PANEL& p)
{
	input->copy_buffer(str);
	input->display(p);
	return(PANEL_RESUME);
}

// end of button.cpp
