/*      Copyright  1990 E.Toyokuni      Number \PL01900908  */

#define PLDWN

#define RT1   1		/*  @  */
#define RT2   2		/*@A  */
#define RT3   3
#define RT4   4
#define RT5   5
#define RT6   6
#define RT7   7
#define RT8   8
#define RT9   9
#define RT10  10
#define RT11  11
#define RT12  12
#define RT13  13
#define RT14  14
#define RT15  15

#define BLACK	0*0X20 +1	/*@B  */
#define BLUE    1*0X20 +1 	/*@C  */
#define RED     2*0X20 +1 
#define PURPLE  3*0X20 +1 
#define GREEN   4*0X20 +1 
#define SKY     5*0X20 +1 
#define YELLOW  6*0X20 +1 
#define WHITE   7*0X20 +1 

#define NONSEC  0x01 		/*@D  */
#define BLINKK   0x02 		/*@E  */
#define REVERSEE 0x04 		/*@F  */
#define UNDERLN 0x08 		/*@G  */

#define FK1   0X001 		/*  H  */
#define FK2   0X002 
#define FK3   0X004 
#define FK4   0X008 
#define FK5   0X010 
#define FK6   0X020 
#define FK7   0X041 
#define FK8   0X081 
#define FK9   0X100 
#define FK10  0X200

#define ERROR   -1		/*  I  */
#define PYES    2		/*  J  */
#define PNO     1

#define GR_SEG		0xa800		/*  K  */
#define GR_OFF  	0x0000 		/*  L  */
#define MENUBUFFLEN	0x6000		/* (26) */
#define ATR_SEG		MENUBUFFLEN / 0x20	/*  M  */

#define		CLS           	printf("\033[2J")	/*  N  */
#define		LINE20        	printf("\033[3h")		/*  O  */
#define		LINE25        	printf("\033[3l")
#define		CURON        	printf("\033[>5l")		/*  P  */
#define		CUROFF        	printf("\033[>5h")
#define		CURLEFT        	printf("\033[1D")		/*  Q  */
#define		CURRIGHT       	printf("\033[1C")
#define		LOCATE(x,y)   	printf("\033[%d;%dH",y,x)	/*  R  */
#define		MYBEEP          putchar('\007')   
#define		HOME          	putchar('\036')    
#define		BOTTOMOFF    	printf("\033[>1h")		/*  S  */
#define		BOTTOMON     	printf("\033[>1l")
#define		KANJI         	printf("\033)0")
#define		GRAPH         	printf("\033)3")

#define		INITDTL		5	/* (21) */
#define		MIDASHILEN	50	/* (22) */
	
#define		PRTPR	 1		/* (23) */			
#define		PRTMN	 2		/* (24) */
#define		PRTEPSON 3		/* (25) */
#define		PRTCANON 4		/* (25) */

