/*
** File Name : popwin.cpp
**
**     User Interface Generator Library For TC++
**     ~    ~         ~
**     Copyright (c) 1990,1991 M.Takayanagi (SSC Co.,Ltd.)
**
**			߯߱ ޳  ׽
**                      ~~~~~~~~~~
*/

#include <stdio.h>
#include <string.h>
#include <process.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include "uiglib.h"

POPWIN::POPWIN(int l, int c, char *msg):PANEL(1,1,25,80,FRAME0, ATTR_CYAN, 32)
{
	int	length, height;
	length = strlen(msg) + 2;
	height = 5;
	TEXT_WINDOW::resize(l,c,height,length);
	parts[nparts++] = new MESSAGE(2,2,ATTR_YELLOW,msg);
}

POPWIN_WAIT::POPWIN_WAIT(int l, int c, char *msg):POPWIN(l, c, msg)
{
	int	l0, c0, ll0, lc0;
	stat(l0,c0,ll0,lc0);
	parts[nparts++] = new BUTTON_QUIT(ll0-1,lc0-7,ATTR_GREEN, "CR:mF", KEY_CR, FRAME0);
}

POPWIN_YES_NO::POPWIN_YES_NO(int l, int c, char *msg):POPWIN(l, c, msg)
{
	int	l0, c0, ll0, lc0;
	stat(l0,c0,ll0,lc0);
	parts[nparts++] = new BUTTON_QUIT(ll0-1,lc0-8,ATTR_GREEN, "Yes", 'Y', FRAME0, ATTR_CYAN, 1);
	parts[nparts++] = new BUTTON_QUIT(ll0-1,lc0-3,ATTR_GREEN, "No ", 'N', FRAME0, ATTR_CYAN, 0);
}

// end of file
