/*
 *	lr|cnr@b`kkr for sb
 *
ڎF
 *	DOS_create(filename,mode)	> handle or err(-1)
 *	DOS_open  (filename,mode)	> handle or err(-1)
 *
 *	DOS_read  (handle,seg,buf,size)	> bytes  or err(-1)
 *	DOS_write (handle,seg,buf,size)	> bytes  or err(-1)
 *	DOS_close (handle)		> err(-1)
 *	DOS_seek  (handle,seekptrL,mode)> err(dx:ax=ffffffffL)
 *	DOS_malloc(paragraph size)	> segment or NULL(0)
 *	movsw(es,di,ds,si,cx);
 *	stosw(es,di,ax,cx);
 */

	name	dos;

DOS	macro	fnc;
	ah=fnc;int(0x21);
	endm;

//	b֐̃Gg[
cproc	macro	_name;
	public	_name;
_name	proc near;
	push(bp);bp=sp;
	endm;

//	b֐̖߂
retproc	macro;
	pop(bp);
	ret;
	endm;

_TEXT	segment	byte public 'CODE';
	DGROUP	group	_DATA,_BSS;
		assume	cs:_TEXT,ds:DGROUP,ss:DGROUP;


//	DOS_create(filename,mode)
cproc _DOS_create;
	dx=[bp+4];
	cx=[bp+6];	// create mode(0x20)
	DOS(0x3C);if(cy) goto err;
	retproc;
_DOS_create endp;

//	DOS_open(filename,mode)
cproc _DOS_open;
	dx=[bp+4];
	al=[bp+6]; 	//0:read 1:write 2:r/w
	DOS(0x3D);if(cy) goto err;
	retproc;
err:	ax=0xffff;dx=ax;
	retproc;
_DOS_open endp;


cproc _DOS_read;
	push(ds);
	bx=[bp+4];
	ax=[bp+6];ds=ax;
	dx=[bp+8];
	cx=[bp+10];
	DOS(0x3f);
	pop(ds);
	if(cy) goto err;
	retproc;
_DOS_read endp;


cproc _DOS_write;
	push(ds);
	bx=[bp+4];
	ax=[bp+6];ds=ax;
	dx=[bp+8];
	cx=[bp+10];
	DOS(0x40);
	pop(ds);
	if(cy) goto err;
	retproc;
_DOS_write endp;


cproc _DOS_close;
	bx=[bp+4];
	DOS(0x3e);if(cy) goto err;
	ax=0;
	retproc;
_DOS_close endp;


cproc _DOS_seek;
	bx=[bp+4];
	dx=[bp+6];
	cx=[bp+8];
	al=[bp+10]; 	// Mode (0:Top 1:Cur 2:end)
	DOS(0x42);if(cy) goto err;
	retproc;
_DOS_seek endp;

cproc _DOS_malloc;
	bx=[bp+4];
	DOS(0x48);if(cy) ax=0;/* NULL */
	retproc;
_DOS_malloc endp;

cproc _movsw;
	push(ds);
	push(es);
	push(si);
	push(di);
	es=[bp+4];
	di=[bp+6];
	ds=[bp+8];
	si=[bp+10];
	cx=[bp+12];
	cld;
	rep movsw;
	
	pop(di);
	pop(si);
	pop(es);
	pop(ds);
	retproc;
_movsw endp;

cproc _stosw;
	push(ds);
	push(es);
	push(si);
	push(di);
	es=[bp+4];
	di=[bp+6];
	ax=[bp+8];
	cx=[bp+10];
	cld;
	rep stosw;
	
	pop(di);
	pop(si);
	pop(es);
	pop(ds);
	retproc;
_stosw endp;

_TEXT	ends;

_DATA	segment word public 'DATA';
_DATA	ends;

_BSS	segment word public 'BSS';
_BSS	ends;

	end;
