;Ղ̌
;=============================================================================
;	iXe[Wqbq[`
;-----------------------------------------------------------------------------
; 1.00	1992-11-21	Created						HaHi
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	include	\game\sys\game.h
	include	\game\stg\stg.h
;=============================================================================
;	@
;=============================================================================
	extrn	STATUS_LINETOP		; status.s
	extrn	STATUS_LINELEN		; status.s
;=============================================================================
;	@
;=============================================================================
	public	stage_rcr_setup
	public	set_map_bc
	public	set_status_bc
	
	public	scroll_update
	public	waku_flag
;=============================================================================
;	@
;=============================================================================
BGX_OFS	=	0
BGY_OFS	=	-$40	;def	STATUS_LINELEN*8+16

clk_0	equ	4
wid_0	equ	32	; 256 mode
HSW_0	=	2
HDS_0	=	$12-wid_0/2
HDW_0	=	wid_0-1
HDE_0	=	43-(HSW_0+1)-(HDS_0+1)-(HDW_0+1)-1

clk_1	equ	5
wid_1	equ	32	; 384 mode
HSW_1	=	3
HDS_1	=	$18-wid_1/2+1
HDW_1	=	wid_1-1
HDE_1	=	57-(HSW_1+1)-(HDS_1+1)-(HDW_1+1)-1

clk_2	equ	5
wid_2	equ	34	; 384 mode
HSW_2	=	3
HDS_2	=	$18-wid_2/2+1
HDW_2	=	wid_2-1
HDE_2	=	57-(HSW_2+1)-(HDS_2+1)-(HDW_2+1)-1

clk_3	equ	5
wid_3	equ	36	; 384 mode
HSW_3	=	3
HDS_3	=	$18-wid_3/2+1
HDW_3	=	wid_3-1
HDE_3	=	57-(HSW_3+1)-(HDS_3+1)-(HDW_3+1)-1
	
clk_4	equ	5
wid_4	equ	38	; 384 mode
HSW_4	=	3
HDS_4	=	$18-wid_4/2+1
HDW_4	=	wid_4-1
HDE_4	=	57-(HSW_4+1)-(HDS_4+1)-(HDW_4+1)-1
	
clk_s	equ	4
wid_s	equ	32	; 256 mode
HSW_s	=	2
HDS_s	=	$12-wid_s/2
HDW_s	=	wid_s-1
HDE_s	=	43-(HSW_s+1)-(HDS_s+1)-(HDW_s+1)-1


MAPBGPAL	def	BGPALBUF+2*$20
;=============================================================================
;	@
;=============================================================================
	seg	zseg
hsync_tbl	ds	2
	seg	dseg
waku_flag	ds	1
;=============================================================================
;	@
;=============================================================================
	seg	int

;-----------------------------------------------------------------------------;
;	stage_rcr_setup
; function:
;	Xe[Wʂ̃X^[̏
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
stage_rcr_setup:
	stz	waku_flag
	lda	#high(stage_hsync)
	ldx	#low (stage_hsync)
	jmp_	set_hsync_entry

;-----------------------------------------------------------------------------;
;	stage_hsync
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
stage_hsync:
	lda	hsync_cnt
	asl	a
	tax
	jmp	[stage_hsync_jtbl,x]

stage_hsync_jtbl:
	dw	stage_hsync_0	; vsync(SPoff)
	dw	stage_hsync_1	; STATUS̏I(SPon,BGoff)
	dw	stage_hsync_2	; NbN؂ւ
	dw	stage_hsync_3	; af\Jn
	dw	stage_hsync_4	; X^[k
	dw	stage_hsync_5	; EChEJn
	dw	stage_hsync_6	; EChEI

stage_hsync_off:
	RCROFF
	rts

stage_hsync_0:
	tst_DSP			; ʂȂ牽Ȃ
	beq	stage_hsync_off
	;
	;	back ground colorɂ(Xe[^X)
	;
	stz	LOTAD
	stz	HITAD
_status_bc_l	equ	*+1
	lda	#0
	sta	LOTDT
_status_bc_h	equ	*+1
	lda	#0
	sta	HITDT
	;
	lda	color_cmd
	beq	not_map_bc_update
	lda	MAPBGPAL+l
	sta	_map_bc_l
	lda	MAPBGPAL+h
	sta	_map_bc_h
not_map_bc_update
	;
	ldb	TEKKAN,#clk_s	; 5MHz clock
	;
	st0	#HSR
	st1	#HSW_s
	st2	#HDS_s
	;
	st0	#HDR
	st1	#HDW_s
	st2	#HDE_s
	;
scroll_update	equ	*+1
	lda	#0
	beq	not_update
	;
	stz	scroll_update
	;
	lda	b_Wx+l
	add	#low (BGX_OFS)
	sta	_bgx_l
	lda	b_Wx+h
	adc	#high(BGX_OFS)
	sta	_bgx_h
	;
	lda	#low (BGY_OFS)
	add	b_REL_Y+l
	sta	_bgy_l
	lda	#high(BGY_OFS)
	adc	b_REL_Y+h
	sta	_bgy_h
	;
	ldy	b_BIG_X
w_BIG_X	equ	*+1
	cpy	#-1
	beq	not_update
	sty	w_BIG_X
	;
	lda	MWR_tbl,y	; 1dot or 2dot space mode
	sta	_MWR
	lda	tekkan_tbl,y
	sta	_TEKKAN
	lda	HSW_tbl,y
	sta	_HSW
	lda	HDS_tbl,y
	sta	_HDS
	lda	HDW_tbl,y
	sta	_HDW
	lda	HDE_tbl,y
	sta	_HDE
	;
	lda	RCR_tbl_l,y
	sta	hsync_tbl+l
	lda	RCR_tbl_h,y
	sta	hsync_tbl+h
	;
not_update:
	st0	#MWR
_MWR	equ	*+1
	st1	#0
	;
	st0	#BXR
BXR_INIT	equ	$000
	st1	#low (BXR_INIT)
	st2	#high(BXR_INIT)
	st0	#BYR
BYR_INIT	def	STATUS_LINETOP*8	; SCڂ
	st1	#low (BYR_INIT)
	st2	#high(BYR_INIT)
	;
	st0	#RCR
RCR1	def	STATUS_LINELEN*8+$40
	st1	#low (RCR1-1)
	st2	#high(RCR1-1)
	;
	SPROFF
	RCRON
	inc	hsync_cnt	;0=>1
	rts

stage_hsync_1:
	st0	#RCR
	st1	#low (RCR1)
	st2	#high(RCR1)
	;
	jsr	lret
	jsr	lret
	jsr	lret
	
	lda	crl_m
	ora	#$40		; SPRON
	sta	_bgon
	and	#$7f		; BGOFF
	sta	crl_m
	inc	hsync_cnt	;1=>2
	;
;
;	ȍ~́A\n܂Ă
;
;
	st0	#BXR
_bgx_l	equ	*+1
	st1	#0
_bgx_h	equ	*+1
	st2	#0
	;
	cly
	jsr	set_BYR
	;-----------------------------
	st0	#HSR
_HSW	equ	*+1
	st1	#0
_HDS	equ	*+1
	st2	#0
	;-----------------------------
	st0	#HDR
_HDW	equ	*+1
	st1	#0
	;
	rts

stage_hsync_2:
_TEKKAN	equ	*+1
	lda	#0
	sta	TEKKAN
	;
	st0	#HDR
;_HDW	equ	*+1
;	st1	#0
_HDE	equ	*+1
	st2	#0
	;
	st0	#RCR
	st1	#low (RCR1+3)
	st2	#high(RCR1+3)
	;
	inc	hsync_cnt	;2=>3
lret:	rts

stage_hsync_3:
	st0	#CR
_bgon	equ	*+1
	st1	#0
	;
	;	back ground color}bv(pbg2̃J[0)ɂ
	;
	stz	LOTAD
	stz	HITAD
	
	
_map_bc_l	equ	*+1
	lda	#0
	sta	LOTDT
_map_bc_h	equ	*+1
	lda	#0
	sta	HITDT
	;
	inc	hsync_cnt	;3=>4
	BGON
	;
	stz	hsync_cnt2
	ldy	#2
set_RCR:
	st0	#RCR
	lda	[hsync_tbl],y
	sta	LO7UP
	iny
	lda	[hsync_tbl],y
	sta	HI7UP
	;
	rts

stage_hsync_4:
	inc	hsync_cnt2
hsync_cnt2	equ	*+1
	lda	#0
	asl	a
	asl	a
	pha
	tay
	iny
	iny
	jsr	set_RCR
	;
	ldx	waku_flag
	beq	stage_hsync_41
	;
WIN_RCR	=	ORGV+(30-8)*8
	cmp	#high(WIN_RCR)
	bne	stage_hsync_40
	dey
	lda	[hsync_tbl],y
	cmp	#low (WIN_RCR)
stage_hsync_40:
	blo	stage_hsync_41
	;
	lda	[hsync_tbl],y
	sec
	adc	#6*8
	sta	win_end_rcr_l
	iny
	lda	[hsync_tbl],y
	adc	#0
	sta	win_end_rcr_h
	;
	inc	hsync_cnt
	;
stage_hsync_41:
	ply
	;
	;	ȉ͐\͂܂Ă
	;
set_BYR:
	st0	#BYR
	lda	[hsync_tbl],y
	clc
_bgy_l	equ	*+1
	adc	#0
	sta	LO7UP
	iny
	lda	[hsync_tbl],y
_bgy_h	equ	*+1
	adc	#0
	bmi	set_BYR_nul	; }bvOȂ
	sta	HI7UP
	;
	rts

set_BYR_nul:			; Oʒu\
	st1	#0
	st2	#0
	rts

stage_hsync_5:
	st0	#RCR
win_end_rcr_l	equ	*+1
	st1	#0
win_end_rcr_h	equ	*+1
	st2	#0
	;
	;	obNJ[ɂǂ
	;
	stz	LOTAD
	stz	HITAD
	stz	LOTDT
	stz	HITDT
	;
	jsr	lret
	jsr	lret
	jsr	lret
;
;	ȍ~́A\n܂Ă
;
WIN_BYR	=	30*8
	st0	#BYR
	st1	#low (WIN_BYR-1)
	st2	#high(WIN_BYR-1)
	SPROFF
	rts

stage_hsync_6:
	BGOFF
	rts
;
MWR_tbl:
	db	%0_101_00_00	; 0
	db	%0_101_10_10	; 1
	db	%0_101_10_10	; 2
	db	%0_101_10_10	; 3
	db	%0_101_10_10	; 4
	;	 | ||| || ++--------VM		00:1dot space 10:2dot space
	;	 | ||| ++-----------SM		00:1dot space 10:2dot space
	;	 | +++--------------SCREEN	64 * 64
	;	 +------------------CM

TEKKAN_tbl:	db	clk_0,clk_1,clk_2,clk_3,clk_4
HSW_tbl:	db	HSW_0,HSW_1,HSW_2,HSW_3,HSW_4
HDS_tbl:	db	HDS_0,HDS_1,HDS_2,HDS_3,HDS_4
HDW_tbl:	db	HDW_0,HDW_1,HDW_2,HDW_3,HDW_4
HDE_tbl:	db	HDE_0,HDE_1,HDE_2,HDE_3,hDE_4


;-------------------------------------------
;c䗦
;	32 chr : 200 line
;	34 chr : 200*34/32=212.5   12 line ΂ 16 line  1line ΂
;	36 chr : 200*36/32=225.0   25 line ΂  8 line  1line ΂
;	38 chr : 200*38/32=237.5   37 line ΂  6 line  1line ΂
;
RCR_tbl_l:
	db	low(WID32_RCR_tbl)	;0
	db	low(WID32_RCR_tbl)	;1
	db	low(WID34_RCR_tbl)	;2
	db	low(WID36_RCR_tbl)	;3
	db	low(WID38_RCR_tbl)	;4
RCR_tbl_h:
	db	high(WID32_RCR_tbl)	;0
	db	high(WID32_RCR_tbl)	;1
	db	high(WID34_RCR_tbl)	;2
	db	high(WID36_RCR_tbl)	;3
	db	high(WID38_RCR_tbl)	;4

_dw_	macro	%1,%2
	dw	%1,%2
	endm

OY	def	RCR1
AD=0

WID32_RCR_tbl:
	dw	         0+AD
	dw	0			; RCR OFF

AD=-2	;AD=-12

WID34_RCR_tbl:
	dw	         0+AD
	_dw_	  8+OY,  9+AD
	_dw_	 24+OY, 26+AD
	_dw_	 40+OY, 43+AD
	_dw_	 56+OY, 60+AD
	_dw_	 72+OY, 77+AD
	_dw_	 88+OY, 94+AD
	_dw_	104+OY,111+AD
	_dw_	120+OY,128+AD
	_dw_	136+OY,145+AD
	_dw_	152+OY,162+AD
	_dw_	168+OY,179+AD
	_dw_	184+OY,196+AD
	dw	0			; RCR OFF

AD=-4	;AD=-25

WID36_RCR_tbl:
	dw	         0+AD
	_dw_	  4+OY,  5+AD
	_dw_	 12+OY, 14+AD
	_dw_	 20+OY, 23+AD
	_dw_	 28+OY, 32+AD
	_dw_	 36+OY, 41+AD
	_dw_	 44+OY, 50+AD
	_dw_	 52+OY, 59+AD
	_dw_	 60+OY, 68+AD
	_dw_	 68+OY, 77+AD
	_dw_	 76+OY, 86+AD
	_dw_	 84+OY, 95+AD
	_dw_	 92+OY,104+AD
	_dw_	100+OY,113+AD
	_dw_	108+OY,122+AD
	_dw_	116+OY,131+AD
	_dw_	124+OY,140+AD
	_dw_	132+OY,149+AD
	_dw_	140+OY,158+AD
	_dw_	148+OY,167+AD
	_dw_	156+OY,176+AD
	_dw_	164+OY,185+AD
	_dw_	172+OY,194+AD
	_dw_	180+OY,203+AD
	_dw_	188+OY,212+AD
;	_dw_	196+OY,221+AD
	dw	0			; RCR OFF

AD=-8	;AD=-37

WID38_RCR_tbl:
	dw	         0+AD
	_dw_	  4+OY,  5+AD
	_dw_	  8+OY, 10+AD
	_dw_	 14+OY, 17+AD
	_dw_	 19+OY, 23+AD
	_dw_	 24+OY, 29+AD
	_dw_	 30+OY, 36+AD
	_dw_	 35+OY, 42+AD
	_dw_	 40+OY, 48+AD
	_dw_	 46+OY, 55+AD
	_dw_	 51+OY, 61+AD
	_dw_	 56+OY, 67+AD
	_dw_	 62+OY, 74+AD
	_dw_	 67+OY, 80+AD
	_dw_	 72+OY, 86+AD
	_dw_	 78+OY, 93+AD
	_dw_	 83+OY, 99+AD
	_dw_	 88+OY,105+AD
	_dw_	 94+OY,112+AD
	_dw_	 99+OY,118+AD
	_dw_	104+OY,124+AD
	_dw_	110+OY,131+AD
	_dw_	115+OY,137+AD
	_dw_	120+OY,143+AD
	_dw_	126+OY,150+AD
	_dw_	131+OY,156+AD
	_dw_	136+OY,162+AD
	_dw_	142+OY,169+AD
	_dw_	147+OY,175+AD
	_dw_	152+OY,181+AD
	_dw_	158+OY,188+AD
	_dw_	163+OY,194+AD
	_dw_	168+OY,200+AD
	_dw_	174+OY,207+AD
	_dw_	179+OY,213+AD
	_dw_	184+OY,219+AD
	_dw_	190+OY,226+AD
;	_dw_	195+OY,232+AD
	dw	0			; RCR OFF

;-----------------------------------------------------------------------------;
;	set_map_bc		/	set_status_bc
; function:
;	}bṽobOJ[ݒ肷
;	Xe[^X̃obOJ[ݒ肷
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
set_map_bc:
;	sta	_map_bc_h
;	stx	_map_bc_l
	rts

set_status_bc:
	sta	SPPALBUF+h		; SP̃pbgOJ[Oɂ
	stx	SPPALBUF+l		; ݒ肷
	sta	_status_bc_h
	stx	_status_bc_l
	rts
;=============================================================================
;	@@
;=============================================================================
