;Ղ̌
;=============================================================================
;	[hI
;-----------------------------------------------------------------------------
; 1.00	1992-11-21	Created						HaHi
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	include	\game\sys\game.h
	include	\game\sys\task.h
	include	\game\sys\batclr.h
	include	\game\sys\moji.h
	include	\game\sys\moji2.h
	include	\game\sys\objman.h
	include	\game\sys\waku.h
	include	\game\sys\vramtfr.h
	include	\game\sys\paltfr.h
	include	\game\sys\bank.h
	include	\game\sys\cdplay.h
	include	\game\sys\sound.h
;	include	data.ext
;=============================================================================
;	@
;=============================================================================
	extrn	moji2_chr,moji_pal		;data.s
	extrn	ryukos_chr,ryukos_pal,ryukos_spt	;data.s
	extrn	waku_chr,waku_pal			;data.s
	
	extrn	option_task
;=============================================================================
;	@
;=============================================================================
	public	modesel_task
	public	modesel_task_reent
	public	ryuko_sp_setup
;=============================================================================
;	@
;=============================================================================
BACK_COLOR	=	%000_000_000	; 
;=============================================================================
;	@
;=============================================================================
	seg	dseg
blink_timer	ds	1	; uNp^C}[
ryukos_ocb	ds	1	;
;=============================================================================
;	@
;=============================================================================
	seg	cseg

modesel_task:
	stz	mode_sel
	;
modesel_task_reent:
	cdplay	BGM_SEL
	;
	jsr	ex_dspoff
	jsr	wait_vsync
	;
	;
	vminit	$1000
	jsr	pl_init
	jsr	obj_init
	;
	jsr	ryuko_sp_setup
	;
	jsr	bat_clear
	;
	mojipal	moji_pal
	moji2setup	moji2_chr
	wakusetup	waku_chr,waku_pal
	;
	jsr	set_back_color
	color_update
	;
	jsr	modesel_menu
	jsr	ex_dspon
	;
	stz	blink_timer
modesel_task_lop:
	next_rts
	;
	jsr	cursor_blink
	inc	blink_timer
	;
	lda	XPAD_TRG_S+0
	ora	XPAD_TRG_X+0
	bit	#JOYA
	bne	modesel_decide_1P
	;
	lda	DIFF_TRG_S	;Strigger Ȃ2pI΂
	beq	skip_2p
	;
	lda	XPAD_TRG_S+1
	ora	XPAD_TRG_X+1
	bit	#JOYA
	bne	modesel_decide_2P
	;
skip_2p:
	lda	joytrg+0	; QoƂPo̓͂nq
	ora	joytrg+1
	bsr	cursor_move
	bra	modesel_task_lop
;
modesel_decide_2P:
	lda	#1
	db	bit_imm
modesel_decide_1P:
	cla
	;
	sta	pl_sel
	sta	story_player
	;
	sdplay	m_kettei
	;
	lda	mode_sel
	cmp	#2
	beq	to_option_task
	;
	jsr	ex_dspoff
	jsr	wait_vsync
	jmp	task_end

to_option_task:
	jmp	option_task
;----------------------------------------------------------------------------
;	J[\̈ړ
;----------------------------------------------------------------------------
cursor_move:
	ldy	#-1
	bit	#JOYUP
	bne	cursor_move1
	ldy	#1
	bit	#JOYDOWN
	bne	cursor_move1
	rts

cursor_move1:
	tya
	add	mode_sel
	cmp	#3
	bhs	cursor_move_err
	pha
	jsr	cursor_off		; ݂̃J[\Ă
	pla
	sta	mode_sel
	stz	blink_timer		; ^C}[(_邽)
	;
	sdplay	m_cursor		; J[\ړ
cursor_move_err:
	rts

cursor_blink
	lda	blink_timer
	bit	#7
	bne	cursor_blink_ret
	bit	#8
	beq	cursor_on
cursor_off:
	lda	#" "
	bra	cursor_onoff
cursor_on:
	lda	#">"
cursor_onoff:
	pha
	ldy	mode_sel
	lda	cursor_ypos_tbl,y
	sta	mjy
	ldb	mjx,#PX+3
	pla
	jmp	moji2_put
cursor_blink_ret:
	rts

cursor_ypos_tbl:
	db	PY+3,PY+5,PY+7

PX=6
PY=16
;-----------------------------------------------------------------------------
;	j[\
;-----------------------------------------------------------------------------
modesel_menu:
	wakuput	PX,PY,20,10
	;
	mojicol	MC_SYAN
	putln2	string_select_mode
	mojicol	MC_GOLD
	putln2	string_vs_mode
	putln2	string_story_mode
	putln2	string_option
	rts

string_select_mode:
	db	PX+3,PY+1," SELECT MODE",0
string_vs_mode:
	db	PX+5,PY+3," VS   MODE",0
string_story_mode:
	db	PX+5,PY+5,"STORY MODE",0
string_option:
	db	PX+5,PY+7,"  OPTION",0
;-------------------------------------------------------------------------
;	obÑXvCg
;-------------------------------------------------------------------------
ryuko_sp_setup:
	lda	#ryukos_chr
	jsr	bk_data_open
	jsr	scg_tfr
	ldw	obj_vadr,tfr_vadr
	;
	lda	#ryukos_pal
	jsr	bk_data_open
	jsr	ps_tfr
	ldb	obj_pal,tfr_pal
	;
	lda	#ryukos_spt
	jsr	bk_data_open
	ldw	obj_tbl,_a0
	;
	stz	obj_group
	jsr	obj_group_def
	;
	objgen	1,0,_BGSP|_DISP,$80,$60		;BǦ
	sty	ryukos_ocb
	;
	rts


set_back_color:
	lea	BGPALBUF,BACK_COLOR
	lea	SPPALBUF,BACK_COLOR
	rts
;=============================================================================
;	@@
;=============================================================================
