	include	\game\sys\game.h
	include	\game\sys\vramtfr.h
	include	\game\sys\paltfr.h
	include	\game\sys\batclr.h
	include	\game\sys\moji.h
	include	\game\sys\moji2.h
	include	\game\sys\task.h
	include	\game\sys\efman.h
	include	\game\sys\objman.h
	include	data.ext
	include	\sys\cdblk.h

	extrn	select_exit
	public	vsstage_task

PX	=	2
PY	=	10

	seg	dseg

sel		ds	1
blink_timer	ds	1

	seg	cseg

vsstage_task:
	jsr	ex_dspoff
	jsr	wait_vsync
	
	vminit	$1000
	jsr	pl_init
	jsr	obj_init
	;
	jsr	bat_clear
	
	mojipal	moji_pal
	moji2setup	moji2_chr
	;
	putln2	string_vs_stage
	;
	color_update
	jsr	ex_dspon
	;
	stz	sel
	stz	blink_timer
vsstage_task_lop
	next_rts
	;
	jsr	blink_cursor
	;
	lda	joytrg+0
	ora	joytrg+1
	bit	#JOYA
	bne	vsstage_decide
	;
	jsr	cursor_move
	bra	vsstage_task_lop

vsstage_decide:
	lda	sel
	extrn	win_sel
	sta	win_sel
	;
	jsr	ef_fadeout
	ef_taskwait
	;
	lda	#CDBLK_sel
	ldy	#1
	jmp	select_exit

cursor_move:
	cly
	bit	#JOYLEFT
	bne	cursor_move1
	iny	;#1
	bit	#JOYRIGHT
	bne	cursor_move1
	rts

cursor_move1:
	phy
	jsr	blink_cursor_off
	pla
	sta	sel
	stz	blink_timer
	rts

blink_cursor:
	lda	blink_timer
	inc	blink_timer
	bit	#7
	bne	blink_cursor_ret
	bit	#8
	bne	blink_cursor_off
blink_cursor_on
	lda	#">"
	bra	blink_cursor_onoff
blink_cursor_off:
	lda	#" "
blink_cursor_onoff:
	pha
	;
	ldx	sel
	lda	mjx_tbl,x
	sta	mjx
	;
	ldb	mjy,#PY
	;
	pla
	jmp	moji2_put

blink_cursor_ret:
	rts

mjx_tbl:
	db	PX,PX+5

string_vs_stage:
	db	PX,PY-4,_PAL1,"VS STAGE",_PAL0,_CRLF
	db	"WHICH PLAYER WIN?",_CRLF
	db	" 1P   2P",0
;=============================================================================
ststage_task:
	jsr	ex_dspoff
	jsr	wait_vsync
	
	vminit	$1000
	jsr	pl_init
	jsr	obj_init
	;
	jsr	bat_clear
	
	mojipal	moji_pal
	moji2setup	moji2_chr
	;
	putln2	string_story_stage
	;
	color_update
	jsr	ex_dspon
	;
	stz	sel
	stz	blink_timer
ststage_task_lop
	next_rts
	;
	jsr	blink_cursor
	;
	lda	joytrg+0
	ora	joytrg+1
	bit	#JOYA
	bne	ststage_decide
	;
	jsr	cursor_move
	bra	ststage_task_lop

ststage_decide:
	lda	sel
	;
	extrn	win_sel
	sta	win_sel
	;
	jsr	ef_fadeout
	ef_taskwait
	;
	lda	#CDBLK_sel
	ldy	#1
	jmp	select_exit

string_story_stage:
	db	PX,PY-4,_PAL1,"STORY STAGE "
	db	"0",_PAL0,0

string_win_lose::
	db	PX,PY-2,"YOU WIN OR LOST?",_CRLF
	db	" WIN  LOSE",0
