;------------------------------------------------------------------------------
;	*** HERO FLAG ***
;------------------------------------------------------------------------------
;BHF_DAMAGE	EQU	0	;get dammage
;BHF_STATE_DISP	EQU	1	;status display
;BHF_NO_BJUDGE	EQU	2	;not back obj judge
;BHF_NO_DIR_CHG	EQU	3	;not dir change
;BHF_DEF_HIT	EQU	4	;defencive hit
;BHF_NON_ACT	EQU	5	;no action
;BHF_ON_OBJ	EQU	6	;in upper range of anther obj
;BHF_OBJ_STOP	EQU	7	;stop on the another obj (not fall down)
HF_DAMAGE	EQU	%00000001
HF_STATE_DISP	EQU	%00000010
HF_NO_BJUDGE	EQU	%00000100
HF_NO_DIR_CHG	EQU	%00001000
HF_DEF_HIT	EQU	%00010000
HF_NON_ACT	EQU	%00100000
HF_ON_OBJ	EQU	%01000000
HF_OBJ_STOP	EQU	%10000000
;-----------------------------------------------------------------------------
;	*** HERO_STATE ***
;-----------------------------------------------------------------------------
;BHS_DEFENCE	EQU	0	;deffence
;BHS_PUNCH	EQU	1	;punch
;BHS_KICK	EQU	2	;kick
;BHS_SPECIAL	EQU	3	;special attack
;BHS_JUMP	EQU	4	;jump
;BHS_DOWN	EQU	5	;sit down
;BHS_DAMAGE	EQU	6	;damage action
;BHS_AUTO	EQU	7	;auto move mode
HS_DEFENCE	EQU	%00000001
HS_PUNCH	EQU	%00000010
HS_KICK		EQU	%00000100
HS_SPECIAL	EQU	%00001000
HS_JUMP		EQU	%00010000
HS_DOWN		EQU	%00100000
HS_DAMAGE	EQU	%01000000
HS_AUTO		EQU	%10000000


;------------------------------------------------------------------------------
;	*** STATE in HERO ***
;------------------------------------------------------------------------------
;BHSS_LOCK_OFF	EQU	0	;nage lock offence
;BHSS_LOCK_DEF	EQU	1	;nage lock defence
;BHSS_NAGERARE	EQU	2	;nagerare
;BHSS_NAGERARE2	EQU	3	;nagerare
HSS_LOCK_OFF	EQU	%00000001
HSS_LOCK_DEF	EQU	%00000010
HSS_NAGERARE	EQU	%00000100
;HSS_NAGERARE2	EQU	%00001000
;-----------------------------------------------------------------------------
;	*** player control  ***
;-----------------------------------------------------------------------------
COMMAND_INT	EQU	%1000_0000	; 7
DAMAGE_END	EQU	%0100_0000	; 6
ATTACK_MODE	EQU	%0010_0000	; 5
SPECIAL_MODE	EQU	%0001_0000	; 4
DIS_SRCH_MODE	EQU	%0000_1000	; 3
COMMAND_STOP	EQU	%0000_0100	; 2
COM_RESULT_END	EQU	%0000_0010	; 1
ACT_COM_MISS	EQU	%0000_0001	; 0

;COM_INT_BIT	EQU	%10000000
;DM_END_BIT	EQU	%01000000
;AT_MODE_BIT	EQU	%00100000
;SP_MODE_BIT	EQU	%00010000
;D_SRCH_BIT	EQU	%00001000
;COM_STOP_BIT	EQU	%00000100
COM_REND_BIT	EQU	%00000010
;COM_MISS_BIT	EQU	%00000001

;-----------------------------------------------------------------------------
;	    *** PLAYER_STARE in PLAYER ***
;-----------------------------------------------------------------------------
;BPS_START_DI	EQU	7		;1=start disable
;BPS_COM_FLAG	EQU	6		;com (0) or player (1)
;BPS_IN_GAME	EQU	5		;player in play for system
;BPS_HK3_INIT	EQU	0		;HK3 system initialize
PS_START_DI	EQU	%10000000
PS_COM_FLAG	EQU	%01000000
PS_IN_GAME	EQU	%00100000
PS_HK3_INIT	EQU	%00000001

