/*#include <std.h>*/

#pragma warn -rvl
#include <stdio.h>

/* vg^Cv */
int  t_peek(int adrs);
void t_poke(int adrs,int data);
void t_exec(char *regs);
void t_readvram( int adrs,int len, char *buf);
void t_writevram(int adrs,int len, char *buf);
void t_readmem( long adrs,int len, char *buf);
void t_writemem(long adrs,int len, char *buf);
void doutw(int i);
void dout( int d);



#if	0
char ver[2];
char csb[8192];
int  cab[256];
Usage(
"Usage| at infile  [.csb .cab]\n"
)

Main
	if(argc<2) usage();

	if(init8255()) {
		printf("Fatal| PIO-9052 Interface Board Trouble!\n");
		exit(1);
	}

	/****** ǂ݂ ******/
	t_sysver(ver);
	printf("system version=%02x.%02x\n",ver[0],ver[1]);

	atctl(argv[1]);
End
#endif

static char ver[2];
static char regs[]={
	/*	 -A-  -X-  -Y-  -P-  -S-  PCL  PCH	*/
		0x00,0x00,0x00,0x04,0xff,0x00,0xe0,0x00,
	/*	mmr0 mmr1 mmr2 mmr3 mmr4 mmr5 mmr6 mmr7	*/
		0xff,0xf8,0x01,0x02,0x03,0x04,0x05,0x00};

#if	0
atctl(name)
char *name;
{
	char s[80];
	int i;

	c62_init();

	strcpy(s,name);strcat(s,".csb");
	Ropen(s);
	Read(csb,8192);
	Rclose();

	t_writevram(0x1000,0x2000,csb);

	strcpy(s,name);strcat(s,".cab");
	Ropen(s);
	fseek(ifp,0x950L,0);
	Read(cab,256);
	Rclose();

	for(i=0;i<32*4;i+=4) {
		if(cab[i+2]==(-1)) {
			int j;
			for(j=i;j<64*4;j++) cab[j]=0;
			break;
		}else{
			cab[i]   += 64+128;
			cab[i+1] += 32+128;
			cab[i+2] += 0x1000 / 32;
		}
	}
	
	t_writevram(0xf00,0x200,(char *)cab);

	sprdma(0xf00);
	setpal(0);
	spron();
}
#endif

int _7upval[]={
	0x0000,		/*;05:CR	*/
	0x0000,		/*;06:RCR	*/
	0x0000,		/*;07:BXR	*/
	0x0000,		/*;08:BYR	*/
/*	0x0000,		  ;09:MWR	; screen 32*32  dot clock2	*/
	0x0050,		/*;09:MWR	; screen 64*64  dot clock2	*/
	0x0202,		/*;0a:HSR	*/
	0x041f,		/*;0b:HDR	*/
	0x0f02,		/*;0c:VPR	*/
	0x00ef,		/*;0d:VDR	*/
	0x0004,		/*;0e:VCR	*/
	0x0000,		/*;0f:DCR	*/
	-1};

c62_init()
{
	int i;
	t_poke(0x400,4); /* TEKKAN=4 */
	
	i=0;while( _7upval[i]!=(-1) ) {
		setreg(5+i,_7upval[i]);
		i++;
	}
}


vsync1()
{
	while( (t_peek(0) & 0x20 )==0 ) ;
}

#define MAWR	0	/*	;W/O vram wright address reg. 	*/
#define MARR	1	/*	;W/O vram read address reg. 	*/
#define VWR	2	/*	;W   vram data write reg. 	*/
#define VRR	2	/*	;R   vram dara read reg. 	*/
#define CR	5	/*	;W/O controll reg. 	*/
#define RCR	6	/*	;W/O raster counter reg.*/
#define BXR	7	/*	;W/O bg x scroll reg. 	*/
#define BYR	8	/*	;W/O bg y scroll reg. 	*/
#define MWR	9	/*	;W/O memory dot space setup. 	*/
#define HSR	10	/*	;W/O h-sync setup 	*/
#define HDR	11	/*	;W/O h-sync setup 	*/
#define VPR	12	/*	;W/O v-sync setup 	*/
#define VDR	13	/*	;W/O v-sync setup 	*/
#define VCR	14	/*	;W/O v-sync setup 	*/
#define DCR	15	/*	;W/O DMA control 	*/
#define SOUR	16	/*	;W/O DMA sou. address 	*/
#define DISR	17	/*	;W/O DMA dis. address 	*/
#define LENR	18	/*	;W/O DMA move counter 	*/
#define DVSSR	19	/*	;W/O SAT address setup 	*/

sprdma(sat)
{
	setreg(DVSSR,sat);
}

spron()
{
	setregl(CR,0x40);
}

dspoff()
{
	setregl(CR,0);
}

setreg(reg,dat)
{
	t_poke(0,reg);
	t_poke(2,dat);
	t_poke(3,dat>>8);
}

setregl(reg,dat)
{
	t_poke(0,reg);
	t_poke(2,dat);
}

static int  col[512]={

		/* イ */
/*todo*/
	 0x0000,0x01fd,0x017b,0x013a,0x00f1,0x00a0,0x01ff,0x01b7
	,0x016d,0x00db,0x00b9,0x0030,0x0058,0x0092,0x0049,0x0008
/*jack*/
	,0x0000,0x01fe,0x01bc,0x013b,0x00f1,0x0069,0x0059,0x01df
	,0x014f,0x00d4,0x0052,0x016d,0x011c,0x0093,0x0049,0x01ff
/*lee*/
	,0x0000,0x01ff,0x01fc,0x016b,0x0099,0x0000,0x01bc,0x012a
	,0x0099,0x0051,0x01b6,0x016d,0x00db,0x0092,0x0049,0x0048
/*king*/
	,0x0000,0x00a0,0x0132,0x017b,0x01bd,0x01ff,0x0049,0x008a
	,0x00d3,0x011c,0x016e,0x01ff,0x01ff,0x01fe,0x01ba,0x01fd
/*mike*/
	,0x0000,0x01bc,0x017b,0x0139,0x00f1,0x0060,0x0058,0x017c
	,0x00fa,0x003a,0x0029,0x01fe,0x01b5,0x012b,0x00d9,0x01fe
/*john*/
	,0x0000,0x01fe,0x01f5,0x01fd,0x01bb,0x0132,0x0161,0x00a9
	,0x0111,0x0089,0x01f9,0x0041,0x0098,0x01b0,0x0040,0x01b8
/*big*/
	,0x0000,0x01ff,0x01fe,0x01bc,0x0172,0x00e8,0x0098,0x0176
	,0x0126,0x00d5,0x008b,0x0051,0x01b6,0x0174,0x0172,0x0130
/*karte*/
	,0x0000,0x01bc,0x017b,0x0132,0x00a9,0x0060,0x0010,0x01ff
	,0x01b6,0x0124,0x0092,0x0049,0x0000,0x0092,0x0124,0x01ff
/*ryo*/
	,0x0000,0x01fd,0x01bc,0x017a,0x0132,0x00a9,0x0058,0x0179
	,0x0139,0x00b0,0x0068,0x0058,0x0000,0x0092,0x0124,0x01ff
/*rob*/
	,0x0000,0x01fd,0x01fc,0x01bb,0x017b,0x013a,0x00b1,0x0069
	,0x0010,0x01ff,0x01f6,0x01ae,0x0166,0x00e5,0x005b,0x000a
/*tit H1*/
	,0x0089,0x01fe,0x01bc,0x017b,0x013a,0x00e9,0x0058,0x0179
	,0x00f9,0x00b0,0x0060,0x0018,0x0000,0x0092,0x0124,0x01ff
/*tit E2*/
	,0x00da,0x01fe,0x01bc,0x017a,0x00f9,0x00a9,0x0019,0x0196
	,0x0105,0x00c3,0x0082,0x01ae,0x011c,0x00d3,0x008a,0x01ff
/*tit H2*/
	,0x0091,0x01fc,0x01bc,0x017b,0x013a,0x00f9,0x00b0,0x0068
	,0x0010,0x01fe,0x01f6,0x01a6,0x0125,0x00a4,0x005b,0x000a
/*tit E5*/
	,0x00da,0x01bc,0x017b,0x013b,0x00f1,0x0060,0x0010,0x017e
	,0x00bc,0x0033,0x0029,0x01bf,0x0176,0x0124,0x009b,0x01ff




	};

setpal(i)
{
	col[i*16]=0;
	t_wrtcol(0,32,col+i*16);
	t_wrtcol(0x100,32,col+i*16);
}

