#include <dos.h>
#pragma inline
#define I asm
char far *BLUE   = (char far *) 0xa8000000L;
char far *RED    = (char far *) 0xb0000000L;
char far *GREEN  = (char far *) 0xb8000000L;
char far *GRAY   = (char far *) 0xe0000000L;
#define VSIZE 0x4000


static int pc_col[]=
{
	0x000,0xe8f,0xd8d,0xc8c,0xb8b,0xa8a,0x989,0x888,
	0x777,0x666,0x555,0x444,0x333,0x222,0x112,0x004,

	0x000,0x111,0x222,0x333,0x444,0x555,0x666,0x777,
	0x808,0x909,0xa0a,0xb0b,0xc0c,0xd0d,0xe0e,0xf0f
};

grp_init98()
{
	int i;
	_AH=0x42;_CH=0xc0;__int__(0x18);/* 400 line */

	outp(0xa6,0) ;			/* CPU Plane0 */
	outp(0x6a,1) ;			/* 16 Colors  */
	gcls();				/* OtBbN@NA */
	_AH=0x40;__int__(0x18);		/* OtBbN@\ */

}


palette98(paldat)
register int *paldat ;
{
	register int i;

	for(i=0;i<16;i++)
	{
		outp(0xa8,i);

		outp(0xaa,(paldat[i]>>5) & 0x0e ) ;
		outp(0xac,(paldat[i]>>2) & 0x0e ) ;
		outp(0xae,(paldat[i]<<1) & 0x0e ) ;
	}
}

dispv98(char far *p)
{
	int i,x,y,z,c,v;
	int c0,c1,c2,c3;
	
	v=0;
	for(y=0;y<199;y++) {
		for(x=0;x<256;x+=8) {
			c0=0;
			c1=0;
			c2=0;
			c3=0;
			
			for(z=0;z<8;z++) {
				c0<<=1;
				c1<<=1;
				c2<<=1;
				c3<<=1;

				c=*p++;
				if(c & 0x01) c0|=1;
				if(c & 0x02) c1|=1;
				if(c & 0x04) c2|=1;
				if(c & 0x08) c3|=1;
			}

			BLUE[v]=c0;
			RED [v]=c1;
			GREEN[v]=c2;
			GRAY[v]=c3;
			v++;
		}
		v+=80-32;
	}
}


gcls()
{
	gcls1(GREEN) ;
	gcls1(RED)   ;
	gcls1(BLUE)  ;
	gcls1(GRAY)  ;
}

static	unsigned char maskbit[]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

vlinev98(x,y,l,c)
{
	while(l--) {
		pset(x,y++,c);
	}
}

vlineh98(x,y,l,c)
{
	while(l--) {
		pset(x++,y,c);
	}
}

pset(x,y,c)
{
	int p,m,n;

	p=(x>>3)+y*80;
	m=maskbit[x&7];n=m^0xff;

	if(c & 0x01) BLUE[p]  |= m;else BLUE[p]  &=n;
	if(c & 0x02) RED [p]  |= m;else RED [p]  &=n;
	if(c & 0x04) GREEN[p] |= m;else GREEN[p] &=n;
	if(c & 0x08) GRAY[p]  |= m;else GRAY[p]  &=n;
}


point(x,y,c)
{
	int p,m,n;

	p=(x>>3)+y*80;
	m=maskbit[x&7];

	c=0;
	if(BLUE[p]  & m) c|=1;
	if(RED [p]  & m) c|=2;
	if(GREEN[p] & m) c|=4;
	if(GRAY[p]  & m) c|=8;

	return(c);
}

gcls1(v)
int far *v;
{
I	push	es;
	_ES=FP_SEG(v);
	_DI=0;
	_AX=0;
	_CX=0x4000;
I	rep stosw;
I	pop	es;
}

putspr(x,y,p)
char *p;
{
	int vp,i,vp0;
	vp0=x*2+y*80*16;
	vp=vp0;

	_SI=(int)p;

	_AX=0xa800;_ES=_AX;
	_CX=16;_DI=vp;_BX=78;
loop1:
I	movsw;
I	add di,bx;
I	loop loop1;

	_AX=0xb000;_ES=_AX;
	_CX=16;_DI=vp;_BX=78;
loop2:
I	movsw;
I	add di,bx;
I	loop loop2;

	_AX=0xb800;_ES=_AX;
	_CX=16;_DI=vp;_BX=78;
loop3:
I	movsw;
I	add di,bx;
I	loop loop3;

	_AX=0xe000;_ES=_AX;
	_CX=16;_DI=vp;_BX=78;
loop4:
I	movsw;
I	add di,bx;
I	loop loop4;

}


