/*
	o`bjml`m	Q[{     By Tateno
*/

#include	<dos.h>
#include	<stdio.h>
#include	<lib\crt.h>
#include	<lib\key.h>
#include	<lib\key98.h>
#include	<lib\keytbl.h>
#include	<lib\memory.h>
#include	<lib\graphic.h>
#include	"packn.h"

char	p[Y][X+2];
int		en;

int		Col[] = { Yellow, Red, Cyan, Green, Magenta, Blue, Yellow, White, Black };

void dispchar(int x, int y, int col, char *ch)
{
	if (ch == NULL)
		disp(x*2-1, y+3, Black, "  ");
	else
		disp(x*2-1, y+3, col, ch);
}

void gdispchar(int x, int y, int col, int no)
{
	if (no == 0) {
		circle(x*16-8, y*16-8+48, 6, col);
		circle(x*16-8, y*16-8+48, 3, col);
	}
}

/* LN^[̈ʒũZbg */
void setup(int *dir, int *x, int *y)
{
	int		i;

	x[0] = SX; 	y[0] = SY;
	for (i = 1; i <= 4; i++)
		x[i] = 18+i, y[i] = 10, dir[i] = 1;
	for (i = 5; i <= 8; i++)
		x[i] = 14+i, y[i] = 11, dir[i] = 4;
}

/* Q[NA */
void gameclear(void)
{
	color(Cyan|Reverse);
	bcls(29, 12, 52, 14);
	dput(34, 13, "STAGE  CLEAR  !!");
	delay(500);
	clrkbuf;
	pause();
}

/* Q[I[o[ */
void gameover(void)
{
	color(Red|Reverse);
	bcls(29, 12, 52, 14);
	dput(34, 13, "GAME  OVER   !!");
	delay(1000);
}

int sum(int *c)
{
	int		i, s = 0;

	for (i = 0; i < en; i++)
		if (c[i] > 0)
			s += c[i];
	return(s);
}

/* x̐ݒ */
int level(int sc)
{
	int		speed, n;

	switch (sc) {
	  case  1: n = 4;	speed = 16;	break;
	  case  2: n = 4;	speed = 14; break;
	  case  3: n = 5;	speed = 14; break;
	  case  4: n = 6;	speed = 14; break;
	  case  5: n = 7;	speed = 12; break;
	  case  6: n = 8;	speed = 12; break;
	  case  7: n = 8;	speed = 10; break;
	  case  8: n = 8;	speed =  9; break;
	  case  9: n = 8;	speed =  8; break;
	  case 10: n = 8;	speed =  6; break;
	}
	en = n + 1;
	return(speed);
}

/* pbN̎c\ */
void disprest(int rest, int wprt)
{
	int		i;

	for (i = 1; i <= 10; i++)
		disp(80-i*2, 3, (i <= rest) ? Yellow :  Black, PACKN);
	for (i = 1; i <= 10; i++)
		disp(56-i*2, 3, (i <= wprt) ? Magenta : Black, PACKN);
}

/* XRA̕\ */
void dispscore(long score)
{
	dispf(12, 3, 5, "Score:%6ld", score);
}

/* G̈ړ̏ */
void emove(int *ox, int *oy)
{
	int		i;

	for (i = 1; i < en; i++) {
		switch (p[oy[i]-1][ox[i]-1]) {
		  case '': dispchar(ox[i], oy[i], Cyan, "E");	    break;
		  case '*': dispchar(ox[i], oy[i], Yellow, "Z");	break;
		  case 'B': dispchar(ox[i], oy[i], White, "");	break;
		  default:  dispchar(ox[i], oy[i], Blue, "  ");     break;
		}
	}
}

/* LN^[̕\ */
void dispc(int *x, int *y, int *rc)
{
	int		i, ec;

	dispchar(x[0], y[0], Col[0], PACKN);
	if (sum(rc) != 0) {
		for (i = 1; i < en; i++) {
			if (rc[i] > 0) {
				rc[i]--;
				ec = (rc[i] <= 150) ? rc[i]%7+1 : Yellow;
			} else {
				if (rc[i] < 0)
					rc[i]++;
				ec = Col[i]|Reverse;
			}
			dispchar(x[i], y[i], ec, ENEMY);
		}
	} else {
		for (i = 1; i < en; i++)
			dispchar(x[i], y[i], Col[i]|Reverse, ENEMY);
	}
}

/* Q[{ */
int game(int sc, int num)
{
	register int	i, j;
	int		x[NUM], y[NUM], dir[NUM];
	int		ox[NUM], oy[NUM];
	int		c = 0, rc[NUM];
	int		speed;
	long	cnt = 0L;
	static long	score = 0L;
	static int	rest = 3, wprt = 3, op = 1;

	speed = level(sc);
	setup(dir, x, y);
	clear(rc);
	disprest(rest, wprt);
	dispf(1, 3, 5, "Stage:%2d", sc);
	do {
		cnt++;
		if ((score/op) > 50000L) {
			op++;
			SOUNDoneup();
			disprest(++rest, ++wprt);
		}
		for (i = 0; i < en; i++)
			ox[i] = x[i], oy[i] = y[i];
		dispc(x, y, rc);
		if (p[y[0]-1][x[0]-1] == '') {
			p[y[0]-1][x[0]-1] = ' ';
			score += 5;
			SOUNDget();
			if (--num == 0) {
				gameclear();
				break;
			}
		} else if (p[y[0]-1][x[0]-1] == '*') {
			p[y[0]-1][x[0]-1] = ' ';
			score += 10;
			for (i = 1; i < en; i++)
				rc[i] = 1200 - sc*50;
		}
		if (c++ == speed) {
			c = 0;
			if (cnt > 150)
				enemy(dir, x, y, rc);
			if (sum(rc))
				SOUNDrev();
			else {
				SOUNDnorm();
				clear(rc);
			}
		} else
			delay(10);
		dir[0] = _inkey();
		move(dir[0], x, y);
		if (dir[0] == ' ' && wprt) {
			warp(x, y);
			disprest(rest, --wprt);
		}
		if (dir[0])
			dispchar(ox[0], oy[0], White, NULL);
		if (sum(rc))
			score += catch(dir, x, y, rc);
		emove(ox, oy);
		dispscore(score);
		if (miss(x, y, rc)) {
			if (--rest == 0) {
				gameover();
				break;
			}
			disprest(rest, wprt);
			emove(x, y);
			setup(dir, x, y);
			clear(rc);
			cnt = 0L;
		}
		switch (dir[0]) {
		  case ESC:	if (pressed() & SHIFT)	return(0);
					turboc();	break;
		  case TAB:	clrkbuf;	pause();	break;
		}
	} while (rest);
	clrkbuf;
	return(rest);
}
