;************************************************************************
;*                   enemy7 action_data					*
;* 				Mr. Big 				*
;*  					1992/7/31			*
;************************************************************************

	extrn	MOTION_001,MOTION_002,MOTION_003,MOTION_004
	extrn	MOTION_005,MOTION_006,MOTION_007,MOTION_008
	extrn	MOTION_009,MOTION_010,MOTION_011,MOTION_012
	extrn	MOTION_013,MOTION_014,MOTION_999
	extrn	UP_DEF_1,UP_DEF_2,UP_DEF_3
	extrn	DOWN_DEF_1

  		include	\game\em.inc

;************************************************************************
E7_TBLNO::
	db	$3B			;e[u
	dw	COMB_001		;1
	dw	COMB_002		;2
	dw	COMB_003		;3
	dw	COMB_004		;4
	dw	COMB_005		;5
	dw	COMB_006		;6
	dw	COMB_007		;7
	dw	COMB_008		;8
	dw	COMB_009		;9
	dw	COMB_010		;A
	
	dw	COMB_011		;B
	dw	COMB_012		;C
	dw	COMB_013		;D
	dw	COMB_014		;E
	dw	COMB_015		;F
	dw	COMB_016		;10
	dw	COMB_017		;11
	dw	COMB_018		;12
	dw	COMB_019		;13
	dw	COMB_020		;14
	
	dw	COMB_021		;15
	dw	COMB_022		;16
	dw	COMB_023		;17
	dw	COMB_024		;18
	dw	COMB_025		;19
	dw	COMB_026		;1A
	dw	COMB_027		;1B
	dw	COMB_028		;1C
	dw	COMB_029		;1D
	dw	COMB_030		;1E
	
	dw	AT_CHUDAN1_SPIA		;1F
	dw	AT_SAKATE_SPIA		;20
	dw	AT_LIFT_SPIA		;21
	dw	AT_MACHINE_SPIA		;22
	dw	AT_MACHINEGUN_SPIA	;23
	dw	AT_DOWN_SPIA		;24
	dw	AT_ROLLING_SPIA		;25
	dw	AT_CROSS_DIVING		;26
	dw	AT_CHUDAN2_SPIA		;27
	
	dw	MOTION_001		;28
	dw	MOTION_002		;29
	dw	MOTION_003		;2A
	dw	MOTION_004		;2B
	dw	MOTION_005		;2C
	dw	MOTION_006		;2D
	dw	MOTION_007		;2E
	dw	MOTION_008		;2F
	dw	MOTION_009		;30
	dw	MOTION_010		;31
	dw	MOTION_011		;32
	dw	MOTION_012		;33
	
	dw	ACT_ONE_STEP		;34
	
	dw	UP_DEF_1		;35
	dw	UP_DEF_2		;35
	dw	ACT_UP_DEF		;37
	
	dw	DOWN_DEF_1		;38
	dw	ACT_CHOHATSU		;39
	dw	COMB_031		;3A
	dw	COMB_032		;3B

;************************************************************************

CHUDAN1_SPIA	EQU	10H
CHUDAN2_SPIA	EQU	21H+80H

SAKATE_SPIA	EQU	22H+80H
LIFT_SPIA	EQU	26H+80H
RIGHT_SPIA	EQU	20H
DOWN_SPIA	EQU	37H+80H
MACHINE_SPIA	EQU	20H
MACHINEGUN_SPIA	EQU	31H+80H
ROLLING_SPIA	EQU	41H+80H
CROSS_DIVING	EQU	40H+80H
DOWN_ATTACK	EQU	42H+80H

;************************************************************************
;
;	*atacked_distance
;
;CHUDAN1_SPIA    => 159
;SAKATE_SPIA     => 153
;LIFT_SPIA       => 141
;RIGHT_SPIA      => 167
;MACHINEGUN_SPIA => 155
;DOWN_SPIA       => 161
;ROLLING_SPIA    => 256
;CROSS_DIVING	 => 256
;
;************************************************************************

ACT_UP_DEF:	actid
	T6_ACT	26,BACK_WALK
	ACT_END
;	T1_ACT
;	db	14h+80h
;	T1_CHG2	DM3,0EH,CHUDAN1_SPIA,NACT,BACK_WALK,60
;	ACT_END

ACT_ONE_STEP:	actid
	T1_ACT
	T1_CHG1	20,FRONT_WALK
	ACT_END

ACT_CHOHATSU:	actid
	T3_ACT	DM0,CHOHATSU,1
	ACT_END

AT_CHUDAN1_SPIA:	actid
	T4_ACT	159,CHUDAN1_SPIA,1
	ACT_END

AT_CHUDAN2_SPIA:	actid
	T4_ACT	180,CHUDAN2_SPIA,1
	ACT_END

AT_LIFT_SPIA:	actid
	T4_ACT	141,LIFT_SPIA,70
	ACT_END

AT_SAKATE_SPIA:
AT_RIGHT_SPIA:	actid
	T4_ACT	153,RIGHT_SPIA,1
	ACT_END

AT_DOWN_SPIA:	actid
	T4_ACT	161,DOWN_SPIA,1
	ACT_END

AT_ROLLING_SPIA:	actid
	T4_ACT	255,ROLLING_SPIA,1
	ACT_END

AT_MACHINE_SPIA:	actid
	T4_ACT	167,MACHINE_SPIA,1
	ACT_END

AT_MACHINEGUN_SPIA:	actid
	T4_ACT	155,MACHINEGUN_SPIA,1
	ACT_END

AT_CROSS_DIVING:	actid
	T4_ACT	255,CROSS_DIVING,1
	ACT_END


COMB_031:	actid
	T1_ACT
	db	DOWN_ATTACK
	T1_CHG8	DM0,120
	T1_CHG0	146,DOWN_SPIA,90
	ACT_END


;
;	*chudan1_hit => lift_spia
;
COMB_001:	actid
	T4_ACT	159,CHUDAN2_SPIA,12
	T4_ACT	141,LIFT_SPIA,24
	ACT_END

;
;	*cross_diving => rolling_spia
;
COMB_002:	actid
	T1_ACT
	db	CROSS_DIVING
	T1_CHG4	161,DOWN_SPIA,12
	ACT_END

;
;	*lift_spia => rolling_spia
;
COMB_003:	actid
	T4_ACT	141,LIFT_SPIA,15
	T4_ACT	255,ROLLING_SPIA,15
	ACT_END

;
;	*cross_diving => machine_spia
;
COMB_004:	actid
	T1_ACT
	db	CROSS_DIVING
	T4_ACT	167,MACHINE_SPIA,12
	ACT_END

;
;	*front_walk => machine_spia => front_walk => machine_spia =>
;
;	*sakate_spia
;
COMB_005:	actid
	T3_ACT	DM0,FRONT_WALK,60
	T4_ACT	167,MACHINE_SPIA,12
	T3_ACT	DM0,FRONT_WALK,60
	T4_ACT	167,MACHINE_SPIA,12
	T4_ACT	153,SAKATE_SPIA,15
	ACT_END

;
;	*machine_spia => machinegun_spia => sakate_spia
;
COMB_006:	actid
	T4_ACT	167,MACHINE_SPIA,12
	T4_ACT	155,MACHINEGUN_SPIA,12
	T4_ACT	153,SAKATE_SPIA,15
	ACT_END

;
;	*front_walk => chudan1_spia => front_walk => chudan1_spia
;
;	*machinegun_spia
;
COMB_007:	actid
	T3_ACT	DM1,FRONT_WALK,60
	T4_ACT	159,CHUDAN2_SPIA,12
	T3_ACT	DM1,FRONT_WALK,12
	T4_ACT	159,CHUDAN2_SPIA,12
	T4_ACT	255,ROLLING_SPIA,15
	ACT_END

;
;	*back_walk => cross_diving => chohatsu
;
COMB_008:	actid
	T1_ACT
	T1_CHG3	DM2,BACK_WALK,90
	db	CROSS_DIVING
	T1_CHG3	DM0,CHOHATSU,1
	ACT_END

;
;	*machine_spia => front_walk(0.3) => chudan1_spia => machinegun_spia
;
COMB_009:	actid
	T1_ACT
	T1_CHG4	167,CHUDAN1_SPIA,12
	T1_CHG1	20,FRONT_WALK
	T1_CHG4	159,CHUDAN2_SPIA,12
	T1_CHG4	155,MACHINEGUN_SPIA,12
	ACT_END

;
;	*lift_spia => machine_spia => rolling_spia
;
COMB_010:	actid
	T4_ACT	141,LIFT_SPIA,15
	T4_ACT	167,MACHINE_SPIA,12
	T4_ACT	255,ROLLING_SPIA,30
	ACT_END

;
;	*front_walk => chudan1_spia => rolling_spia
;
COMB_011:	actid
	T3_ACT	DM1,FRONT_WALK,60
	T4_ACT	159,CHUDAN2_SPIA,12
	T4_ACT	255,ROLLING_SPIA,30
	ACT_END

;
;	*chudan1_spia => chudan1_spia => back_walk => machine_spia
;
COMB_012:	actid
	T4_ACT	167,CHUDAN2_SPIA,12
	T4_ACT	167,CHUDAN1_SPIA,12
	T3_ACT	DM2,BACK_WALK,60
	T4_ACT	167,CHUDAN1_SPIA,12
	ACT_END

;
;	*lift_spia => front_walk => machine_spia
;
COMB_013:	actid
	T4_ACT	141,LIFT_SPIA,15
	T3_ACT	DM0,FRONT_WALK,60
	T4_ACT	167,CHUDAN1_SPIA,12
	ACT_END

;
;	*lift_spia => chudan1_spia => machine_spia => sakate_spia
;
COMB_014:	actid
	T4_ACT	141,LIFT_SPIA,15
	T4_ACT	167,CHUDAN2_SPIA,12
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	153,SAKATE_SPIA,12
	ACT_END

;
;	*back_walk => chudan1_spia => machinegun_spia => sakate_spia
;
COMB_015:	actid
	T3_ACT	DM2,BACK_WALK,60
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	155,MACHINEGUN_SPIA,12
	T4_ACT	153,SAKATE_SPIA,12
	ACT_END

;
;	*rolling_spia => machine_spia => sakate_spia
;
COMB_016:	actid
	T4_ACT	255,ROLLING_SPIA,30
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	153,SAKATE_SPIA,12
	ACT_END

;
;	*chudan1_spia => machine_spia => machine_spia => sakate_spia
;
COMB_017:	actid
	T4_ACT	159,CHUDAN2_SPIA,12
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	153,SAKATE_SPIA,24
	ACT_END

;
;	*lift_spia => machine_spia => machine_spia => sakate_spia
;
COMB_018:	actid
	T4_ACT	141,LIFT_SPIA,70
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	153,SAKATE_SPIA,24
	ACT_END

;
;	*lift_spia => front_walk => sakate_spia
;
COMB_019:	actid
	T4_ACT	141,LIFT_SPIA,70
	T3_ACT	DM0,FRONT_WALK,60
	T4_ACT	153,SAKATE_SPIA,12
	ACT_END

;
;	*front_walk => lift_spia => machine_spia
;
COMB_020:	actid
	T3_ACT	DM0,FRONT_WALK,60
	T4_ACT	141,LIFT_SPIA,70
	T4_ACT	176,CHUDAN1_SPIA,12
	ACT_END

;
;	*front_walk => lift_spia => machine_spia
;
COMB_021:	actid
	T3_ACT	DM1,FRONT_WALK,60
	T4_ACT	141,LIFT_SPIA,70
	T4_ACT	176,CHUDAN1_SPIA,12
	ACT_END

;
;	*front_walk => roling_spia => machine_spia
;
COMB_022:	actid
	T3_ACT	DM1,FRONT_WALK,240
	T4_ACT	255,ROLLING_SPIA,70
	T4_ACT	167,CHUDAN1_SPIA,12
	ACT_END

;
;	*rolling_spia => chudan1_spia => chudan1_spia
;
COMB_023:	actid
	T4_ACT	255,ROLLING_SPIA,30
	T4_ACT	159,CHUDAN2_SPIA,12
	T4_ACT	159,CHUDAN2_SPIA,12
	ACT_END

;
;	*rolling_spia => machine_spia => sakate_spia
;
COMB_024:	actid
	T4_ACT	255,ROLLING_SPIA,30
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	153,SAKATE_SPIA,12
	ACT_END

;
;	*lift_spia => machine_spia => rolling_spia
;
COMB_025:	actid
	T4_ACT	141,LIFT_SPIA,15
	T4_ACT	167,CHUDAN1_SPIA,12
	T4_ACT	255,ROLLING_SPIA,30
	ACT_END

;
;	*rolling_spia => lift_spia => front_walk => machine_spia
;
COMB_026:	actid
	T4_ACT	255,ROLLING_SPIA,30
	T4_ACT	141,LIFT_SPIA,15
	T3_ACT	DM0,FRONT_WALK,60
	T4_ACT	167,CHUDAN1_SPIA,12
	ACT_END

;
;	*front_walk => foot_work => front_walk
;
COMB_027:	actid
	T3_ACT	DM1,FRONT_WALK,60
	T3_ACT	DM0,NACT,60
	T3_ACT	DM0,FRONT_WALK,60
	ACT_END

;
;	*back_walk => foot_work => back_walk
;
COMB_028:	actid
	T3_ACT	DM1,BACK_WALK,60
	T3_ACT	DM0,NACT,60
	T3_ACT	DM0,BACK_WALK,60
	ACT_END

;
;	*kiryoku_power_on
;
COMB_029:	actid
	T1_ACT
	T1_CHG8	DM0,180
	ACT_END

COMB_030:	actid
	T1_ACT
	db	FDASH
	T1_CHG3	DM0,FRONT_WALK,30
	T1_CHG4	161,DOWN_SPIA,18
	ACT_END

COMB_032:	actid
	T3_ACT	DM0,CHOHATSU,1
	T1_ACT
	db	ROLLING_SPIA
	ACT_END


;************************************************************************
