;Ղ̌
;=============================================================================
;	HK3.src
;-----------------------------------------------------------------------------
; 1.00	1992-11-21	Created						HaHi
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	include	\game\sys\game.h
	include	stg.h
;=============================================================================
;	@
;=============================================================================
	extrn	ANOTHER_PLAYER				; stg.s
;=============================================================================
;	@
;=============================================================================
	public	INIT_HK3
	public	ACTION_PROG
;=============================================================================
;	@
;=============================================================================
;=============================================================================
;	@
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	seg	hk3
;-----------------------------------------------------------------------------;
;	INIT_HK3
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
INIT_HK3:
	ldx	pl_sel
	;
	tst	#PS_HK3_INIT,p_PLAYER_STATE,x	; tOĂȂ
	beq	INIT_HK3
	rts

INIT_HK3_1:					; 
	lda	#PS_HK3_INIT
	ora	p_PLAYER_STATE,x
	sta	p_PLAYER_STATE,x
	;
	lda	h_HERO_TYPE,x	; Yreg = HERO_TYPE *6
	asl	a
	add	h_HERO_TYPE,x
	asl	a
	tay
	lda	INIT_HK3_TBL+0+l,y
	sta	p_DIS_SHORT_l,x
	lda	INIT_HK3_TBL+0+h,y
	sta	p_DIS_SHORT_h,x
	;
	lda	INIT_HK3_TBL+2+l,y
	sta	p_DIS_MID_l,x
	lda	INIT_HK3_TBL+2+h,y
	sta	p_DIS_MID_h,x
	;
	lda	INIT_HK3_TBL+4+l,y
	sta	p_DIS_LONG_l,x
	lda	INIT_HK3_TBL+4+h,y
	sta	p_DIS_LONG_h,x
	;
	jsr	INIT_SET
	rts

INIT_HK3_TBL:
;		DIS_SHORT,DIS_MID,DIS_LONG
	dw	$118	,$0b0	,$231	; RYO
	dw	$118	,$0b0	,$231	; ROB
	dw	$078	,$f8	,$150	; TOD
	dw	$0a0	,$10c	,$150	; JAC
	dw	$07d	,$0f0	,$150	; LEE
	dw	$070	,$0f0	,$150	; KIN
	dw	$080	,$0f8	,$150	; MIC
	dw	$078	,$0d0	,$150	; JOH
	dw	$0a8	,$0f0	,$150	; BIG
	dw	$082	,$120	,$150	; KAR


;-----------------------------------------------------------------------------;
;	INIT_SET
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
INIT_SET:
	jsr_	INIT_NEWS
	;
	ldb	random_seed,main_count
	;
	ldx	pl_sel
	stz	p_DG_TBLNO,x
	stz	p_WIN_ROUND,x
	;
	stz	p_PLAYER_CONTROL,x
	stz	p_DEF_IN_COUNT,x
	stz	p_X_DIS_l,x
	stz	p_X_DIS_h,x
	stz	p_X_DIS_NEG_l,x
	stz	p_X_DIS_NEG_h,x
	stz	p_ACTION_ADRS,x
	stz	p_ACT_WAIT,x
;	stz	p_TIME_MODE,x		; ̃[N̓Tu[`̃e|I
	stz	p_STATE_CNT,x
	stz	p_SRCH_TIMER,x
	stz	p_SP_SEQ_LV,x
	stz	p_SPEED_RANK,x
	stz	p_ATTACK_ON,x
	stz	p_ACT_ON,x
	lda	#17
	sta	p_EM_STEP,x
	;
	rts

;-----------------------------------------------------------------------------;
;	HK3_SYSTEM
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
HK3_SYSTEM:
	ldx	pl_sel
	tst	#PS_COM_FLAG,p_PLAYER_STATE,x
	bne	HK3_1
	;
	;	MOVEQ.L	#3,D0
	;	AND.B	DEBUG_DIP1(A5),D0
	;	BNE.S	HK3_1
HK3_2:
	tst	#PS_HK3_INIT,p_PLAYER_STATE,x
	bne	HK3_3
	;
	jsr	INIT_HK3_1
HK3_3:
	stz	h_PLAY_LEVERn,x
	stz	h_PLAY_LEVERt,x
	stz	h_PLAY_LEVERr,x
	;
	jsr	ACTION_SYSTEM
	;
	;	fobO@\gjR̓p\
	;
	rts

;
;	lԑ̂Ƃ
;
HK3_1:
	lda	XPAD_DATA_S,x
	and	#$0f
	sta	_hahi1
	lda	XPAD_DATA_X,x
	asl	a
	asl	a
	asl	a
	asl	a
_hahi1	equ	*+1
	ora	#0
	sta	h_PLAY_LEVERn,x
	;
	lda	XPAD_TRG_S,x
	and	#$0f
	sta	_hahi2
	lda	XPAD_TRG_X,x
	asl	a
	asl	a
	asl	a
	asl	a
_hahi2	equ	*+1
	ora	#0
	sta	h_PLAY_LEVERt,x
	;
	lda	XPAD_REL_S,x
	and	#$0f
	sta	_hahi3
	lda	XPAD_REL_X,x
	asl	a
	asl	a
	asl	a
	asl	a
_hahi3	equ	*+1
	ora	#0
	sta	h_PLAY_LEVERr,x
	;
	rts
;-----------------------------------------------------------------------------;
;	ACTION_SYSTEM
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
ACTION_SYSTEM:
	jsr_	RAND8		; Acc = 8 bit random
	jsr_	NEWS
	;
	ldx	pl_sel
	ldy	ANOTHER_PLAYER,x
	;
	lda	h_X_POSITION_l,y	; GX - X
	sub	h_X_POSITION_l,x
	sta	p_X_DIS_l,x
	sta	_d0_l
	lda	h_X_POSITION_h,y
	sbc	h_X_POSITION_h,x
	sta	p_X_DIS_h,x
	sta	_d0_h
	bpl	ACT_SYS_1
	;
	neg_w	_d0			; ̐ΒlƂ
	;
ACT_SYS_1:
	lda	p_X_DIS_NEG_l,x
	sta	p_OLD_X_DIS_l,x
	lda	p_X_DIS_NEG_h,x
	sta	p_OLD_X_DIS_h,x
	;
	lda	_d0_l
	sta	p_X_DIS_NEG_l,x
	lda	_d0_h
	sta	p_X_DIS_NEG_h,x
	;
	jsr_	DISTANCE_SEARCH		; hk3_sub.s
	jsr_	FORCE_DATA_SET		;player_level_setting ( hk3_set.s )
	jsr_	MINE_STATE_SET		; hk3_sub.s
	;
	ldx	pl_sel
	lda	p_EM_STEP,x
	asl	a
	tay
	lda	ACTION_PROG+l,y
	sta	jsr_adrs+l
	lda	ACTION_PROG+h,y
	sta	jsr_adrs+h
jsr_adrs	equ	*+1
	jsr	0
	;
	jsr	TRI_MOVE
	jsr	NEAR_ATTACK
	rts

	extrn	INIT_DIS_SET	  
	extrn	COM_INT1	  
	extrn	COM_INT2	  
	extrn	COM_INT3	  
	extrn	COM_INT4	  
	extrn	DEFENCE_WAIT	  
	extrn	DEFENCE_NEXT	  
	extrn	SANKAKU_PROG	  
	extrn	UP_DEFENCE	  
	extrn	DOWN_DEFENCE	  
	extrn	hk3_SPECIAL_CHECK	  
	extrn	ATTACK_CHECK      
	extrn	SCLIM_CHECK       
	extrn	AT_BF_CHECK	  
	extrn	HK3_DMG		 
	extrn	HK3_JUMP_DMG	 
	extrn	DIS_SRCH_CHK	
	


ACTION_PROG:
	dw	PROG_DUMMY	;0
	dw	INIT_DIS_SET	;1
	dw	COM_INT1	;2 command_interrupt type 1 operation
	dw	COM_INT2	;3 command_interrupt type 2 operation
	dw	COM_INT3	;4 command_interrupt type 3 operation
	dw	COM_INT4	;5 command_interrupt type 4 operation
	dw	DEFENCE_WAIT	;6
	dw	DEFENCE_NEXT	;7
	dw	SANKAKU_PROG	;8
	dw	UP_DEFENCE	;9
	dw	DOWN_DEFENCE	;10
	dw	hk3_SPECIAL_CHECK	;11
	dw	ATTACK_CHECK    ;12
	dw	SCLIM_CHECK     ;13
	dw	AT_BF_CHECK	;14
	dw	HK3_DMG		;15
	dw	HK3_JUMP_DMG	;16
	dw	DIS_SRCH_CHK	;17

PROG_DUMMY:
	rts
;-----------------------------------------------------------------------------
NEAR_ATTACK:
	ldy	pl_sel
	ldx	ANOTHER_PLAYER,y
	;
	tst	#HS_DAMAGE,h_HERO_STATE,x	; ̃Xe[^X
	bne	NA_NON
	;
	tst	#HS_DOWN,h_HERO_STATE,x
	beq	NA_1
	;
	ldx	pl_sel
	tst	#HS_JUMP,h_HERO_STATE,x		; ̃Xe[^X
	bne	NA_1
	;
	tst	#HS_DOWN,h_HERO_STATE,x
	bne	NA_1
	;
	rts
NA_1:
	ldx	pl_sel
	lda	h_HERO_TYPE,x
	asl	a
	asl	a
	asl	a
	add	LEVEL_TEMP
	tay
	lda	NA_DIST,y
	cmp	p_X_DIS_NEG_l,x
	cla
	sbc	p_X_DIS_NEG_h,x
	blo	NA_NON
	;
	jsr_	RAND8
	and	#A_BUTTON|B_BUTTON	; ł`Ca{^
	;
	ora	h_PLAY_LEVERt,x
	sta	h_PLAY_LEVERt,x
NA_NON:
	rts
NA_DIST:
	db	48,48,48,48,48,48,48,48		;H1
	db	48,48,48,48,48,48,48,48		;H2
	
	db	02,04,08,16,24,32,40,48		;E1
	db	02,04,08,16,24,32,40,48		;E2
	db	08,12,16,24,32,40,48,56		;E3
	db	16,32,48,48,50,52,54,54		;E4
	db	16,32,48,48,50,52,54,54		;E5
	db	02,04,08,16,24,32,40,48		;E6
	db	16,32,48,48,48,56,56,56		;E7
	db	32,48,56,56,56,56,56,56		;E8

;-----------------------------------------------------------------------------
TRI_MOVE:
	ldx	pl_sel
	
	tst	#HS_JUMP,h_HERO_STATE,x
	beq	TRI_NON
	;
	lda	h_ACT_CTRL,x
	cmp	#$20
	bhs	TRI_NON
	;
	lda	h_HERO_TYPE,x
	asl	a
	asl	a
	asl	a
	add	LEVEL_TEMP
	tay
	;
	lda	TRI_DIST,y	; 0 or 1 or 2
	beq	TRI_NON
	;
	dec	a
	bne	TRI_MOVE_01
	;
	lda	p_LIMIT_STOP,x
	beq	TRI_NON
	bra	TRI_MOVE_02

TRI_MOVE_01:
	lda	h_AREA_POSITION,x
	beq	TRI_NON
TRI_MOVE_02:
	;
	lda	h_VZ_l,x
	sta	_d0_l
	lda	h_VZ_h,x
	sta	_d0_h
	bpl	TRI_MOVE_1
	;
	neg_w	_d0
	;
TRI_MOVE_1:
	;
;		CMP.L	#30000H,D0
;		BCC.S	TRI_NON
	;
	lda	#C_BUTTON
	ora	h_PLAY_LEVERt,x
	lda	#C_BUTTON|DOWN
	ora	h_PLAY_LEVERn,x
TRI_NON:
	rts

 if 0
TRI_EI:
		DC.B	1,1
;			1 2 3 4 5 6 7 8
		DC.B	1,0,1,1,0,1,0,1
 endif

LS		EQU	1	;LIMIT_STOP
AP		EQU	2	;AREA_POSITION+HERO_OFFSET

TRI_DIST:
;	level	 0 ,1 ,2 ,3,4 ,5 ,6 ,7
	db	00,00,00,00,00,00,00,00		;H1
	db	00,00,00,00,00,00,00,00		;H2
	
	db	00,00,LS,LS,AP,AP,AP,AP		;E1
	db	00,00,00,00,00,00,00,00		;E2
	db	00,00,LS,LS,AP,AP,AP,AP		;E3
	db	00,LS,LS,LS,AP,AP,AP,AP		;E4
	db	00,00,00,00,00,00,00,00		;E5
	db	00,LS,LS,AP,AP,AP,AP,AP		;E6
	db	00,00,00,00,00,00,00,00		;E7
	db	00,LS,AP,AP,AP,AP,AP,AP		;E8

;=============================================================================
;	@@
;=============================================================================
