;Ղ̌
;=============================================================================
;	HK3_INT.SRC
;-----------------------------------------------------------------------------
; 1.00	1992-11-21	Created						HaHi
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	include	\game\sys\game.h
	include	stg.h
;=============================================================================
;	@
;=============================================================================
	extrn	ACTION_PROG				; hk3.s
;=============================================================================
;	@
;=============================================================================
	public	COM_INT
	public	COM_INT1,COM_INT2,COM_INT3,COM_INT4
;=============================================================================
;	@
;=============================================================================
;=============================================================================
;	@
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	seg	hk3

;-----------------------------------------------------------------------------;
;	COM_INT	
; function:
;	action command interrupt program
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
COM_INT:
	ldx	pl_sel
	lda	p_EM_INT,x
	cmp	#1
	bne	COM_INT_OPE
	;
	stz	p_EM_INT,x
	rts

COM_INT_OPE:
	asl	a
	tax
	;
	jmp	[ACTION_PROG,x]

;-----------------------------------------------------------------------------;
;	COM_INT1
; function:
;	*now_player lock
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
COM_INT1:
	ldx	pl_sel
	;
	stz	p_ACT_COM,x
	;
	lda	#%1111_1000
	and	p_PLAYER_CONTROL,x
	sta	p_PLAYER_CONTROL,x
;		JOB_CLEAR
	
	stz	p_EM_INT,x
	rts

;-----------------------------------------------------------------------------;
;	COM_INT2
; function:
;	*command_data_skip
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
COM_INT2:
	rts

 if 0
		MOVE.W	ACT_COM(A6),D0
		SUBQ.W	#2,D0
		BNE	A2_SKIP_1

		ADD.L	#1,ACTION_ADRS(A6)
A2_SKIP_1:
		SUBQ.W	#3,D0
		BNE	A2_SKIP_2

		ADD.L	#1,ACTION_ADRS(A6)
A2_SKIP_2
		CMP.B	#3,1(A0)
		BNE	ADRS_SKIP

		ADD.L	#4,ACTION_ADRS(A6)
ADRS_SKIP:
		CLR	EM_INT(A6)

;		JOB_CLEAR
		RTS
 endif

;-----------------------------------------------------------------------------;
;	COM_INT3
; function:
;	*com_ope interrupt
;		action_data creative program
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
COM_INT3:
	rts

;-----------------------------------------------------------------------------;
;	COM_INT4
; function:
;	*com_ope interrupt
;		act_operation checker program
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
COM_INT4:
	ldx	pl_sel
	;
	lda	#%1100_0000
	and	p_PLAYER_CONTROL,x
	beq	COM_INT4_NEXT
	;
	tst	#HS_JUMP,h_HERO_STATE,x
	jeq	COM_INT4_END
	;
	asl	a			; bit 7 => cy
	jcs	LANDING_CHECK
 	;
 	lda	p_ACT_COM,x
	beq	to1	;COM_OPE_CLEAR
	;
	dec	a
	beq	to1	;COM_OPE_CLEAR
COM_INT4_NEXT:
	lda	p_ACTION_ADRS_l,x
	sta	_a0
	lda	p_ACTION_ADRS_h,x
	sta	_a0_h
	;
	lda	p_ACT_COM,x
	asl	a
	tax
	jmp	[CHECKER_PROG,x]


CHECKER_PROG:
	dw	CHK_SKIP	;0
	dw	CHK_ACT1	;1
	dw	CHK_ACT2	;2
	dw	CHK_ACT3	;3
	dw	CHK_ACT4	;4
	dw	CHK_ACT5	;5
	
	dw	CHK_ACTS0	;6
	dw	CHK_ACTS1	;7
	dw	CHK_ACTS2	;8
	dw	CHK_ACTS3	;9
	dw	CHK_ACTS4	;10
	dw	CHK_ACTS5	;11
	dw	CHK_ACTS0	;12
	dw	CHK_SKIP	;13
;-----------------------------------------------------------------------------
;	CHK_ACT1	/	CHK_ACTS0	/	CHK_ACTS1
;-----------------------------------------------------------------------------
CHK_ACT1:
	lda	[_a0]
	cmp	#$f0
	beq	SUB_ACT_CHK
	;
	lda	#$11
	sub	[_a0]
	beq	COM_INT4_SET
	;
	lda	#$21
	sub	[_a0]
	beq	COM_INT4_SET
CHK_ACTS0:
CHK_ACTS1:
to1:	jmp	COM_OPE_CLEAR

;-----------------------------------------------------------------------------
;	CHK_SKIP
;-----------------------------------------------------------------------------
CHK_SKIP:
	rts

SUB_ACT_CHK:
	ldy	#1
	lda	[_a0],y
	;
	tay
	lda	SUB_CHK_TBL,y
	beq	to3	;COM_OPE_CLEAR
	;
	ldy	#3
	lda	[_a0],y		;jump_kick or jump_punch code check
	sta	_d0
	
	lda	#$11
	sub	_d0
	beq	COM_INT4_SET
	;
	lda	#$21
	sub	_d0
	beq	COM_INT4_SET
	;
to3:	jmp	COM_OPE_CLEAR

SUB_CHK_TBL:
;		0:1:2:3:4:5
	db	0,0,0,1,1,1

;----------------------------------------------------------------------------
;	CHK_ACT3/CHK_ACT4/CHK_ACT5/CHK_ACTS3/CHK_ACTS4/CHK_ACTS5
;----------------------------------------------------------------------------
CHK_ACT3:
CHK_ACT4:
CHK_ACT5:
CHK_ACTS3:
CHK_ACTS4:
CHK_ACTS5:
	ldx	pl_sel
	lda	#$11
	sub	p_SUCCESS_LEVER,x
	beq	to2	;COM_INT4_SET
	;
	lda	#$21
	sub	p_SUCCESS_LEVER,x
	beq	to2	;COM_INT4_SET
	;
	jmp	COM_OPE_CLEAR

to2:	jmp	COM_INT4_SET
;----------------------------------------------------------------------------
;	CHK_ACT2/CHK_ACTS2
;----------------------------------------------------------------------------
CHK_ACT2:
CHK_ACTS2:
	ldx	pl_sel
	;
	lda	#$11
	cmp	p_SUCCESS_LEVER,x
	beq	COM_INT4_SET
	;
	cmp	p_FAIL_LEVER,x
	beq	COM_INT4_SET
	;
	lda	#$21
	cmp	p_SUCCESS_LEVER,x
	beq	COM_INT4_SET
	;
	cmp	p_FAIL_LEVER,x
	beq	COM_INT4_SET
	;
	jmp	COM_OPE_CLEAR

COM_INT4_SET:
	ldx	pl_sel
	lda	#%0100_0000	; bit 6
	ora	p_PLAYER_CONTROL,x
	sta	p_PLAYER_CONTROL,x
	rts

;-----------------------------------------------------------------------------;
;	LANDING_CHECK
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
LANDING_CHECK:
	ldx	pl_sel
	;
	ldy	h_ACT_CTRL,x
	beq	INT4_NEXT_1
	;
	lda	INT4_TBL,y
	beq	COM_INT4_END
INT4_NEXT_1:
	cpy	#$0c
	bne	INT4_NEXT_3
	;
	lda	#COM_RESULT_END
	ora	p_PLAYER_CONTROL,x
	sta	p_PLAYER_CONTROL,x
INT4_NEXT_3:
	rts

COM_INT4_END:
	tst	#%0001_0000,h_HERO_STATE,x
	bne	INT4_NEXT_2
	;
	lda	#%0011_1000
	ora	p_PLAYER_CONTROL,x
	sta	p_PLAYER_CONTROL,x
	;
	stz	p_EM_INT,x
INT4_NEXT_2:
	rts


INT4_TBL:
;		0:1:2:3:4:5:6:7:8:9:A:B:C:D:E:F
	db	0,0,0,0,0,0,1,0,0,1,0,1,0,0,0,0	;0	<**
	db	0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0	;1
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	;2
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	;3
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	;4
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	;5
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	;6
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	;7

COM_OPE_CLEAR:
	ldx	pl_sel
	lda	#%1000_0100
	ora	p_PLAYER_CONTROL,x
	sta	p_PLAYER_CONTROL,x
;		BSET.B	#7,PLAYER_CONTROL(A6)
	rts

;=============================================================================
;	@@
;=============================================================================
