;Ղ̌
;=============================================================================
;	ʂ̈΂^k߃[`
;-----------------------------------------------------------------------------
; 1.00	1992-11-21	Created						HaHi
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	include	\game\sys\game.h
	include	\game\sys\task.h
;=============================================================================
;	@
;=============================================================================
	extrn	div8
;=============================================================================
;	@
;=============================================================================
	public	gamen_stretch
	public	gamen_shorten
	public	gamen_stretch_kill
;=============================================================================
;	@
;=============================================================================
LINEMAX	=	240
;=============================================================================
;	@
;=============================================================================
	seg	dseg
view_line	ds	1	; 1 ` LINEMAX/2
;=============================================================================
;	@
;=============================================================================
	seg	cseg

stretch_tcb	db	-1

gamen_stretch:
	lda	#0
	jsr	sta_hsync_ofst
	;
	lda	#high(hsync_entry)
	ldx	#low (hsync_entry)
	jsr	set_hsync_entry
	;
	taskgen	gamen_stretch_task,$10
	stx	stretch_tcb
	rts

gamen_shorten:
	taskgen	gamen_shorten_task,$10
	stx	stretch_tcb
	rts

gamen_stretch_kill:
	ldx	stretch_tcb
	bmi	not_kill
	lda	#-1
	sta	stretch_tcb
	jmp	task_kill
not_kill:
	rts

;-----------------------------------------------------------------------------;
;	gamen_stretch_task	/	gamen_shorten_task
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
gamen_stretch_task:
	;
	lda	#4
gamen_stretch_task_lop:
	sta	view_line
	next_rts
	;
	jsr	set_hsync_ofst
	;
	lda	view_line
	add	#4
	cmp	#LINEMAX/2+2
	blo	gamen_stretch_task_lop
	;
	ldb	stretch_tcb,#-1
	jmp	task_end


gamen_shorten_task:
	lda	#LINEMAX/2
gamen_shorten_task_lop:
	sta	view_line
	next_rts
	;
	jsr	set_hsync_ofst
	;
	lda	view_line
	sub	#4
	bne	gamen_shorten_task_lop
	;
	jsr	ex_dspoff
	;
	ldb	stretch_tcb,#-1
	jmp	task_end
;-----------------------------------------------------------------------------;
;	hsync_entry
; function:
;	
; argument:
;	
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
hsync_entry:
	ldx	hsync_cnt
	bne	hsync_entry1
	;--------------------------
	;	BXR ̐ݒ
	;--------------------------
	st0	#BXR
	lda	bgx1+l
	sta	LO7UP
	lda	bgx1+h
	sta	HI7UP
hsync_entry1:
	cpx	#LINEMAX
	bhs	hsync_entry_end
	;--------------------------
	;	BYR ̐ݒ
	;--------------------------
	st0	#BYR
	lda	hsync_ofst,x
	add	bgy1+l
	sta	LO7UP
	cla
	adc	bgy1+h
	sta	HI7UP
	;--------------------------
	;	BYR ̐ݒ
	;--------------------------
	st0	#RCR
	lda	hsync_cnt
	add	#$40+1
	sta	LO7UP
	cla
	rol	a
	sta	HI7UP
	;
	RCRON
	inc	hsync_cnt
	rts

hsync_entry_end:
	RCROFF
	rts

hsync_ofst:
	ds	LINEMAX
;------------------------------------------------------------------------------
;	hsync_ofst[]Accŏ
;------------------------------------------------------------------------------
sta_hsync_ofst:
	clx
sta_hsync_ofst_lop:
	sta	hsync_ofst,x
	inx
	cpx	#LINEMAX
	blo	sta_hsync_ofst_lop
	;
	rts
;------------------------------------------------------------------------------
;	view_line  240 CԈĕ\悤
;	hsync_ofst ɒlݒ肷
;	
;	+----------------------+
;	|                      |
;	|                      |
;	|----------------------|          -
;	|                      |		̊Ԃ̃Cview_line
;	+----------------------+ʒ  -
;	|                      |
;	|----------------------|
;	|                      |
;	|                      |
;	+----------------------+
;
;------------------------------------------------------------------------------
line_num	def	_d1_l
line_val	def	_d2_l
line_ofs	def	_d2_h

set_hsync_ofst:
	stz	line_val	; ώZli܂j
	stz	line_ofs	; ړC
	cla
set_hsync_ofst_lop:
	sta	line_num	; JE^
	;
	; view_line : LINEMAX/2 = line_num : ????
	; ???? = LINEMAX/2 * line_num / view_line
	;
	lda	#LINEMAX/2	
	add	line_val
	;
	ldy	view_line
	jsr	div8		; Acc / Yreg = Acc ] Yreg
	sty	line_val
	;
	add	line_ofs
	sta	line_ofs
	;------------------------Ɉ
	lda	#LINEMAX/2
	sub	line_num
	tax
	;
	lda	#LINEMAX/2
	sub	line_ofs
	sta	hsync_ofst,x
	;------------------------艺Ɉ
	lda	#LINEMAX/2
	add	line_num
	tax
	;
	lda	#LINEMAX/2
	add	line_ofs
	sta	hsync_ofst,x
	;
	lda	line_num
	inc	a
	cmp	view_line
	blo	set_hsync_ofst_lop
	;
	bra	set_hsync_ofst_ent2
;-----------------------------------view ȊO0 ɂ
set_hsync_ofst_lop2:
	sta	line_num
	;
	lda	#LINEMAX/2
	sub	line_num
	tax
	stz	hsync_ofst,x
	;
	lda	#LINEMAX/2
	add	line_num
	tax
	stz	hsync_ofst,x
	;
	lda	line_num
	inc	a
set_hsync_ofst_ent2:
	cmp	#LINEMAX/2
	blo	set_hsync_ofst_lop2
	;
	rts
;=============================================================================
;	@@
;=============================================================================
