;Ղ̌
;=============================================================================
;	ur[hO
;-----------------------------------------------------------------------------
; 1.00	1993-09-01	Created						HaHi
;=============================================================================
;=============================================================================
;	@
;=============================================================================
	include	\game\sys\game.h
	include	\game\sys\objman.h
	include	\game\sys\task.h
	include	\game\sys\efman.h
	include	\game\sys\vramtfr.h
	include	\game\sys\paltfr.h
	include	\game\sys\objdef.h
	include	\game\sys\moji.h
	include	\game\sys\moji1.h
	include	\game\sys\moji2.h
	include	\game\sys\moji3.h
	include	\game\sys\sound.h
;=============================================================================
;	@
;=============================================================================
	extrn	cursor_chr,cursor_pal,cursor_spt	;data.s
	extrn	moji_pal,moji2_chr,moji3_chr		;data.s
	extrn	moji1_chr				;data.s
;=============================================================================
;	@
;=============================================================================
	public	vsname_task
	public	LOST_PLAYER
;=============================================================================
;	@
;=============================================================================
RANKMAX	equ	5
RANKSIZ	equ	4	; byte
NAMEMAX	equ	3	; R

BACK_COLOR	=	%100_000_000	; 

RANK_XPOS1	=	2	; 1ST,2ND,3RD,4TH,5TH	4char
RANK_XPOS2	=	7	; score			16char
RANK_XPOS3	=	25	; NAME			6char
RANK_XPOS4	=	13	; l		10char
;=============================================================================
;	@
;=============================================================================
	seg	zseg
_rank		ds	2	; rank[N|C^
	seg	dseg
rank		ds	1	; =0`RANKMAX-1
rank_Yreg	ds	1	; =rank * RANKSIZ
score_buf	ds	8+1	; XRAobt@
name_pos	ds	1	; O|WV(0`NAMEMAX-1)
moji_ptr	ds	3	; e[u|C^[
blink_count
blink_timer	ds	1	; uNp^C}[
LOST_PLAYER	ds	1	; v[ԍ 0 or 1
;cursor_ocb	ds	1	; J[\ԍ
cursor2_ocb	ds	1	; J[\ԍ
;=============================================================================
;	@
;=============================================================================
	seg	cseg

;-----------------------------------------------------------------------------;
;	vsname_task
; function:
;	
; argument:
;	WIN_PLAYER: v[
; return:
;	
; modify:
;	
; note:
;	
;-----------------------------------------------------------------------------;
vsname_task:
	lda	#1
	eor	WIN_PLAYER
	sta	LOST_PLAYER
	;
	jsr	vsname_entry_check
	jcc	vsname_task_exit	; o^̕KvȂ
	;
	vminit	$1000
	jsr	pl_init
	jsr	obj_init
	;
	objdef	cursor_chr,cursor_pal,cursor_spt,0
;	objgen	$20,1,_BGSP|_NDSP,$80,0
;	sty	cursor_ocb
	objgen	$10,0,_SPBG|_NDSP,0,0
	sty	cursor2_ocb
	;
	jsr_	bat_clear
	;
	mojipal	moji_pal
	moji1setup	moji1_chr
	moji2setup	moji2_chr
	moji3setup	moji3_chr
	;
	push	rank
	jsr	disp_vs_rank
	pop	rank
	;
	jsr	set_name_hsync
	;
	jsr	set_back_color
	color_update
	;
	stz	name_pos
	stz	blink_timer
vsname_task_lop:
	next_rts
;	jsr	cursor_disp
	jsr	cursor2_blink
	jsr	name_input
	lda	name_pos
	cmp	#NAMEMAX
	blo	vsname_task_lop
	;
;	lda	cursor_ocb
;	jsr	obj_kill
	lda	cursor2_ocb
	jsr	obj_kill
	;
	ldb	blink_count,#10
vsname_blink_lop:
	jsr	set_name_hsync
	sleep	#7
	cla
	jsr	set_hsync_entry
	sleep	#7
	dec	blink_count
	bne	vsname_blink_lop
	;
	jsr	ef_fadeout
	ef_taskwait
	;
vsname_task_exit:
	jmp	task_end

;----------------------------------------------------------------------------
;	O͂
;----------------------------------------------------------------------------
name_input:
	;
	ldx	LOST_PLAYER
	lda	joytrg,x
	bit	#JOYA
	bne	name_input_decide
	bit	#JOYB
	bne	name_input_cancel
	bit	#JOYUP|JOYLEFT
	bne	name_input_dec
	bit	#JOYDOWN|JOYRIGHT
	bne	name_input_inc
	rts

name_input_cancel:
	lda	name_pos
	beq	name_input_cancel_ret
	;
	sdplay	m_kettei
	dec	name_pos
name_input_cancel_ret:
	rts

name_input_decide:
	sdplay	m_kettei		; 艹
	;
	inc	name_pos
	rts

name_input_inc:
	ldx	name_pos
	inc	moji_ptr,x
	lda	moji_ptr,x
	cmp	#moji_tbl_len
	blo	name_input_exe
	;
	stz	moji_ptr,x
	bra	name_input_exe

name_input_dec:
	ldx	name_pos
	dec	moji_ptr,x
	bpl	name_input_exe
	lda	#moji_tbl_len-1
	sta	moji_ptr,x
name_input_exe:
	jsr	set_rank_adrs2
	;
	sdplay	m_cursor		; J[\ړ
	;
	;	͂s
	;
	ldy	name_pos
	ldx	moji_ptr,y
	iny
	lda	moji_tbl,x
	sta	[_rank],y
	;
	;	O\
	;
	ldy	rank		; 0`4
	lda	rank_ypos_tbl,y
	sta	mjy
	;
	mojicol	MC_SYAN
	ldb	mjx,#RANK_XPOS3
	jsr	disp_rank_name2	; O
	rts

moji_tbl:
	db	"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	db	"0123456789"
	db	"'?!"
moji_tbl_len	equ	*-moji_tbl
;----------------------------------------------------------------------------
;	J[\_ł
;----------------------------------------------------------------------------
cursor2_blink:
	lda	blink_timer
	inc	blink_timer
	bit	#7
	bne	cursor_blink_ret
	ldy	cursor2_ocb
	bit	#8
	bne	cursor_off
cursor_on:
	ldx	rank
	lda	cursor_ypos_tbl,x
	sta	ocb_yl,y
	ldx	name_pos
	lda	cursor_xpos_tbl,x
	sta	ocb_xl,y
	;
cursor_on_ent:
	lda	#not(_NDSP)
	and	ocb_atr,y
	sta	ocb_atr,y
cursor_blink_ret:
	rts

cursor_off:
	lda	#_NDSP
	ora	ocb_atr,y
	sta	ocb_atr,y
	rts
;---------------------------------
;	obNJ[\
;---------------------------------
 if 0
cursor_disp:
	ldy	cursor_ocb
	ldx	rank
	lda	cursor_ypos_tbl,x
	sta	ocb_yl,y
	bra	cursor_on_ent
 endif
cursor_xpos_tbl:
	db	(RANK_XPOS3+0)*8
	db	(RANK_XPOS3+2)*8
	db	(RANK_XPOS3+4)*8
;---------------------------------------------------------------------------
;	ur[h̃LO
;---------------------------------------------------------------------------
disp_vs_rank:
	mojicol	MC_GOLD
	;
	lda	LOST_PLAYER
	add	#"1"
	sta	plynum
	putln2	string_vs_ranking
	;
	cla
disp_vs_rank_lop:
	sta	rank
	;
	bsr	disp_vs_rank_one
	;
	lda	rank
	inc	a
	cmp	#5
	blo	disp_vs_rank_lop
	;
	rts

disp_vs_rank_one:
	ldy	rank		; 0`4
	lda	rank_ypos_tbl,y
	sta	mjy
	;
	bsr	set_rank_adrs2	; _rank score[ÑAhXZbg
	;
	mojicol	MC_SYAN
	ldb	mjx,#RANK_XPOS1
	bsr	disp_rank_num	; 1ST,2ND,3RD,4TH,5TH
	
	mojicol	MC_GOLD
	ldb	mjx,#RANK_XPOS4
	bsr	disp_rank_score2; XRA
	;
	mojicol	MC_SYAN
	lea	strptr,string_l
	jsr	moji3_putln
	;
	mojicol	MC_SYAN
	ldb	mjx,#RANK_XPOS3
	jsr	disp_rank_name2	; O
	rts

set_rank_adrs2:
	lda	rank
	ldy	#4
	jsr_	mul8
	add	#low (RANK_TD_V)
	sta	_rank+l
	cla
	adc	#high(RANK_TD_V)
	sta	_rank+h
	rts

disp_rank_name2:
	ldy	#1
disp_rank_name_ent:
	ldx	#3
disp_rank_name_lop:
	lda	[_rank],y
	phx
	phy
	jsr	moji3_put
	ply
	plx
	iny
	dex
	bne	disp_rank_name_lop
	;
	rts

disp_rank_score2:
	clx
	lda	[_rank]
	jsr	bcd_to_string
	stz	score_buf,x
	;
	lea	strptr,score_buf
	jsr_	zero_suppress
	jsr	moji3_putln
	rts

bcd_to_string:
	pha
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	ora	#"0"
	sta	score_buf,x
	inx
	;
	pla
	and	#$0f
	ora	#"0"
	sta	score_buf,x
	inx
	rts

disp_rank_num:
	lda	rank
	asl	a
	asl	a
	add	#low(rank_num_tbl)
	sta	strptr+l
	cla
	adc	#high(rank_num_tbl)
	sta	strptr+h
	;
	lda	[strptr]
	jsr	moji3_put
	;
	incw	strptr
	inc	mjy
	jsr	moji1_putln
	dec	mjy
	;
	rts

string_vs_ranking:
	db	4,5,"PLAYER "
plynum:	db	0		;<= "1" or "2"
	db	"   INPUT YOUR NAME",0
string_l:
	db	"Ƿ",0

rank_ypos_tbl:
	db	9,12,15,18,21
cursor_ypos_tbl:
	db	9*8,12*8,15*8,18*8,21*8

rank_num_tbl:
	db	"1ST",0
	db	"2ND",0
	db	"3RD",0
	db	"4TH",0
	db	"5TH",0

;-----------------------------------------------------------------------------
;	ur[hŕv[̏
;	NC邩H
;	out ) cy=0 NCȂ
;	      cy=1 NC
;		   ɃN[N͓]ĂB
;		   rank : 0`RANKMAX-1
;-----------------------------------------------------------------------------
vsname_entry_check:
	ldx	LOST_PLAYER
	lda	h_HERO_BEAT,x
	;
	cly
	stz	rank
vsname_entry_check_lop:
	cmp	RANK_TD_V+0,y
	beq	vsname_entry_check_skp
	bhs	vsname_entry_hit
vsname_entry_check_skp:
	inc	rank
	say
	add	#RANKSIZ
	say
	cpy	#RANKSIZ*RANKMAX
	blo	vsname_entry_check_lop
	;
	clc
	rts

vsname_entry_hit:
	sty	rank_Yreg
	;
	ldy	#RANKSIZ*(RANKMAX-1)
	bra	vsname_entry_tfr_ent

vsname_entry_tfr_lop:
	phy
	jsr	vsname_tfr
	ply
	;
	tya
	sub	#RANKSIZ
	tay
vsname_entry_tfr_ent:
	cpy	rank_Yreg
	bne	vsname_entry_tfr_lop
	;
	ldx	LOST_PLAYER
	lda	h_HERO_BEAT,x
	sta	RANK_TD_V+0,y		; o^
	lda	#""			; ONA
	sta	RANK_TD_V+1,y
	sta	RANK_TD_V+2,y
	sta	RANK_TD_V+3,y
	stz	moji_ptr+0
	stz	moji_ptr+1
	stz	moji_ptr+2
	;
	sec
	rts

vsname_tfr:
	ldx	#RANKSIZ
vsname_tfr_lop:
	lda	RANK_TD_V-RANKSIZ,y
	sta	RANK_TD_V,y
	iny
	dex
	bne	vsname_tfr_lop
	rts
;-----------------------------------------------------------------------------
;	
;-----------------------------------------------------------------------------
set_back_color:
	lea	BGPALBUF,BACK_COLOR
	lea	SPPALBUF,BACK_COLOR
	rts

;-----------------------------------------------------------------------------
;	name hsync
;-----------------------------------------------------------------------------
set_name_hsync:
	lda	#high(name_hsync)
	ldx	#low (name_hsync)
	jsr	set_hsync_entry
	lda	rank
	asl	a
	tay
	lda	name_rcr_tbl+l,y
	sta	first_rcr_l
	add	#16+8
	sta	second_rcr_l
	lda	name_rcr_tbl+h,y
	sta	first_rcr_h
	adc	#0
	sta	second_rcr_h
	rts

name_hsync:
	lda	hsync_cnt
	asl	a
	tax
	jmp	[name_hsync_jtbl,x]

name_hsync_jtbl:
	dw	name_hsync_0
	dw	name_hsync_1
	dw	name_hsync_2

name_hsync_0:
	stz	LOTAD
	stz	HITAD
	ldb	LOTDT,#low (BACK_COLOR)
	ldb	HITDT,#high(BACK_COLOR)
	;
	st0	#RCR
first_rcr_l	equ	*+1
	st1	#0
first_rcr_h	equ	*+1
	st2	#0
	RCRON
	;
	stz	LOTAD
	stz	HITAD
	inc	hsync_cnt	; 0=>1
	rts

BACK_COLOR2	=	%000_111_000	; 

name_hsync_1:
;	stz	LOTAD
;	stz	HITAD
	ldb	LOTDT,#low (BACK_COLOR2)
	ldb	HITDT,#high(BACK_COLOR2)
	;
	st0	#RCR
second_rcr_l	equ	*+1
	st1	#0
second_rcr_h	equ	*+1
	st2	#0
	;
	stz	LOTAD
	stz	HITAD
	inc	hsync_cnt	; 1=>2
	rts

name_hsync_2:
;	stz	LOTAD
;	stz	HITAD
	ldb	LOTDT,#low (BACK_COLOR)
	ldb	HITDT,#high(BACK_COLOR)
	;
	RCROFF
	rts

name_rcr_tbl:
	dw	 9*8-4+$40
	dw	12*8-4+$40
	dw	15*8-4+$40
	dw	18*8-4+$40
	dw	21*8-4+$40

;=============================================================================
;	@@
;=============================================================================
