/*
 *
 *	LN^e[ủ͂ƃtHg\
 *
 *
 *
 *
 */
#pragma warn -rvl
#include <std.h>
#include <stdlib.h>
#define FONTDIR "D:\\sv\\e\\font"


typedef struct {
	char max;
	int  ptr;
} CHT1;

typedef struct {
	char time;
	char flag;
	char hit;
	int  ptr;
} CHT2;




char ver[2];
char csb[8192];
int  cab[256];
char buf[10240];
int	vflag=1;
int	dflag=0;
int	stageno;
int	majorno=0;
char	binname[80];
char	dirname[80];
int	wrtpage=0;
char	fontdir[80]=FONTDIR;
extern	int	machine;
char	*direnv;
int	palno;

char *dirnametbl[]=
{
	"TODO",
	"JACK",
	"LEE",
	"KING",
	"MIKE",
	"JOHN",
	"BIG",
	"KARTE",

	"RYO",
	"ROB",
	"TITLE",
	""
};
char *binnametbl[]=
{
	"ch_e1.bin",
	"ch_e2.bin",
	"ch_e3.bin",
	"ch_e4.bin",
	"ch_e5.bin",
	"ch_e6.bin",
	"ch_e7.bin",
	"ch_e8.bin",

	"ch_h1.bin",
	"ch_h2.bin",
	"ch_tit.bin",
	""
};

Usage(
	"parse enemy_no [major]\n"
	"		 major = 0..63\n"
	"	0	TODO\n"
	"	1	JACK\n"
	"	2	LEE\n"
	"	3	KING\n"
	"	4	MIKE\n"
	"	5	JOHN\n"
	"	6	BIG\n"
	"	7	KARTE\n"
	"	8	RYO\n"
	"	9	ROB\n"
	"	10	TITLE\n"
	"	-v  verbose\n"
	"	-q  quiet!\n"
	"	-d  debug\n"
	"	-c  current dir (csb file)\n"
	"ϐ PARSE ɃtHg̃fBNgĂ\n"
)

Main
	if(argc<2) usage();
	if(IsOpt('v')) vflag=2;
	if(IsOpt('q')) vflag=0;
	if(IsOpt('d')) dflag=1;
	machine=machine_chk();
	
	direnv=getenv("PARSE");
	if( direnv!=NULL ) strcpy(fontdir,direnv);
	
	stageno=atoi(argv[1]);

	if(argc>=3)
	majorno=atoi(argv[2]);

	parse();
End

parse()
{
	if(init8255()) {
		printf("Fatal| PIO-9052 Interface Board Trouble!\n");
		exit(1);
	}

	t_sysver(ver);
	printf("system version=%02x.%02x\n",ver[0],ver[1]);

	c62_init();

	
	Ropen(binnametbl[stageno]);
	Read(buf,10240);
	Rclose();
	
	if(stageno==10) parsedemo(buf);
	else parse1(buf);
}

atctl(c,x,y)
{
	char s[80];
	char name[80];
	static int  oldc=(-1);
	int i;

/*	x=(x*4)/5;
	y=(y*4)/5;
*/
	if(c==oldc) return;

	wrtpage++;if(wrtpage>=8) wrtpage=1;
	oldc=c;

	/*dspoff();*/
	if(IsOpt('c')) {
		sprintf(name,"P%03x",c);
	}else{
		sprintf(name,"%s\\%s\\P%03x",fontdir,dirnametbl[stageno],c);
	}
	
	strcpy(s,name);strcat(s,".csb");
	ifp=fopen(s,"rb");
	if(ifp==NULL) {
		printf("warning:can't open file:%s\n",s);
		return;
	}
	Read(csb,8192);
	Rclose();

	//ԉ҂
	if(IsOpt('w')) {
		int w,z;
		z=5;
		sscanf(Opt('w'),"%d",&z);
		for(w=0;w<z;w++)
	t_writevram(wrtpage*0x1000,0x2000,csb);
	}

	t_writevram(wrtpage*0x1000,0x2000,csb);

	strcpy(s,name);strcat(s,".cab");
	Ropen(s);
	fseek(ifp,0x950L,0);
	Read(cab,256);
	Rclose();

	for(i=0;i<32*4;i+=4) {
		if(cab[i+2]==(-1)) {
			int j;
			for(j=i;j<64*4;j++) cab[j]=0;
			break;
		}else{
			cab[i]   += 64+256-y;
			cab[i+1] += 32+192+x;
			cab[i+2] += wrtpage*0x1000 / 32;
		}
	}
	
	t_writevram(0xf00,0x200,(char *)cab);

	sprdma(0xf00);

	if(stageno==10) {
		setpal(stageno+palno);
	}else{
		setpal(stageno);
	}

	spron();
}

parsedemo(p)
CHT1 *p;
{
	int i;
	p+=majorno;

	for(i=majorno;i<4;i++) {
		palno=i;
		if(vflag)printf(";%02x  max=%d\n",i,p->max);
		parse2(p->max, i ,buf + (p->ptr) );
		p++;
	}
}

parse1(p)
CHT1 *p;
{
	int i;
	p+=majorno;

	for(i=majorno;i<64;i++) {
		if(vflag)printf(";%02x  max=%d\n",i,p->max);
		parse2(p->max, i ,buf + (p->ptr) );
		p++;
	}
}

parse2(max,maj,p)
CHT2 *p;
{
	int i;
	for(i=0;i<max;i++) {
		if(vflag>1)printf("	CHT2 time=%02x,flag=%02x,hit=%02x	;%02x:%02x\n",
			p->time,
			p->flag,
			p->hit,
			maj,i
		);
		if(vflag>1)printf(";$%04x\n",(p->ptr));
		parse3(p->hit, buf + (p->ptr) );
		p++;
	}
}

/* hit = 
;		/-----gard		attack ;use macro
;		l/----weak point	  ;UHIT,UHIT_off
;		ll/---head
;		lll/--body1
;		llll/-body2
;		00000
 */
static	atctl_c=0;
static	atctl_x=0;
static	atctl_y=0;

parse3(hit,p)
char *p;
{
	int i;
	for(i=0;i<5;i++) {
		if(hit & 0x10) {
			if(vflag>1)printf("	HIT %2d,%2d,%2d,%2d\n",
				p[0]*2,p[2]*2,p[1]*2,p[3]*2
			);
			p+=4;
		}
		hit<<=1;
	}
	atctl_c=(-1);
	parse4(p);

	if(dflag==0) {
		if(atctl_c!=(-1)) atctl(atctl_c,atctl_x,atctl_y);
	}
}

int csize[0x1e]={
	1,1,3,1,1,4,3,1,
	7,2,9,5,5,5+4,1,8,
	13,1,3,6,2,6,5,5,
	5,2,1,1,6,6
};

char *cname[0x1e]={
	"CEND",		"BLINK",	"GOSUB",	"RET",		
	"PAL_OFF",	"SUBP0",	"SOUND",	"FLIP",		
	"USER",		"LOOP",		"FACE",		"UHIT",		
	"UHIT2",	"UHITD",	"UHIT_OFF",	"JUMP",		
	"JUMP3",	"JUMP_OFF",	"NEXTS",	"ADC",		
	"KAGE",		"BLODS",	"EFFECT",	"LANG_SOUND",	
	"DEAD_SOUND",	"RET100",	"RET100_OFF",	"HIT_LOCK_OFF",	
	"GETA",		"MEGANE"	
};








/*
 80	1 CEND				f[^̏I[
 81	1 BLINK				
 82	3 GOSUB(ADDRESS)		Tu[`f[^
 83	1 RET				Tu[`f[^̕A
 84	1 PAL_OFF			
 85	4 SUBP0(max,ADD)		㑱R[ȟ
 86	3 SOUND(SND)			TEh
 87	1 FLIP				
 88	7 USER(Dw,Dw,Dw)		
 89	2 LOOP(count)
 8a	9 FACE(No1 h l,No2 h l,No3 h l,x,y)
 8b	5 UHIT  (x1,y1,x2,y2)
 8c	5 UHIT2 (x1,y1,x2,y2)
 8d	5 UHITD (x1,y1,x2,y2)
	4 UHITD2(x1,y1,x2,y2)
 8e	1 UHIT_OFF
 8f	8 JUMP (type,VZ,az,VX,ax)	сI
 90    13 JUMP3(VZ,az,VX,ax, VZ2,az2,VX2,ax2) 
 91	1 JUMP_OFF
 92	3 NEXTS(NEXT_CODE)
 93	6 ADC(command,VX,VY)
 94	2 KAGE(no)			e
 95	6 BLODS(X,Y,type)
 96	5 EFFECT(C1,C2)
 97	5 LANG_SOUND(C1,C2)
 98	5 DEAD_SOUND(C1,C2)
 99	2 RET100(no)
 9a	1 RET100_OFF
 9b	1 HIT_LOCK_OFF
 9c	6 GETA(X,Y,type)
 9d	6 MEGANE(X,Y,type)
*/

parse4(p)
unsigned char  *p;
{
	int d,c,x,y;

	while(1) {
	if(vflag>1)printf(";$%04x\n",p-buf);
	d=*p;
	if( d<0x80 ) {
		c=p[0]*256+p[1];
		y=p[2];x=p[3];p+=4;
		
		if(c&1) x=-x;
		if(c&2) y=-y;
		c>>=2;
		if(vflag)printf("	CODE	%04x,%d,%d\n",
			c,x,y);
		if(atctl_c==(-1)) {
			atctl_c=c;
			atctl_x=x;
			atctl_y=y;
		}
		if(dflag) atctl(c,x,y);
		/*atctl(c);*/
	}else{
		if(d>=0x9e) {
			printf("	TABLE ERR %x(%x)\n",p-buf,d);
			exit(1);
		}else{
			d&=0x7f;
			if(vflag>1)printf("	%s\n",cname[d]);
			if(d==0) return;
			if(d==2) {		/* gosub */
				int subadrs;
				subadrs=p[1]+(p[2]<<8);
				p =buf+subadrs;
			}else{
				p+=csize[d];
			}
		}
	}
	
	}
}
